#!/bin/sh
# abainfo.sh - ABACUS information
# the next line restarts using wish \
exec wish "$0" "$@" -geometry +0+0

# Edit this by all means, but be careful of syntax!
# A '#' starts a comment
# A \ at the end of a line is a continuation, miss it out at your own risk!
# quite marks much match each other. etc. etc.
# If you do an edit, try it out frequently. Tcl/tk throughs up an error window
# if it can't understand something; you then can chose to see a stack listing, which might
# be of some help!


#-geometry +0+550

set bold "-background #43ce80 -relief raised -borderwidth 1"
set normal "-background {} -relief flat"

set w .page
wm title . [format "Abacus Information" ]

#image create photo Pic

frame $w 
frame $w.frame
pack $w $w.frame
text $w.frame.mess  -wrap word  -width 80 -height 24  -setgrid true \
-yscrollcommand "$w.frame.s set"
scrollbar $w.frame.s -orient vert -command "$w.frame.mess yview"
pack $w.frame.s -side right -fill y
pack $w.frame.mess -side left -fill both -expand true

set family Courier
set family helvetica

$w.frame.mess tag configure norm 	-font -*-$family-medium-R-Normal--*-120-*-*-*-*-*-*
$w.frame.mess tag configure bold 	-font -*-$family-Bold-R-Normal--*-120-*-*-*-*-*-*
$w.frame.mess tag configure big 	-font -*-$family-Bold-R-Normal--*-140-*-*-*-*-*-*
$w.frame.mess tag configure bigcenter 	-justify center  -underline true\
	-font -*-$family-Bold-R-Normal--*-140-*-*-*-*-*-*
$w.frame.mess tag configure verybigblue -justify center -foreground blue -underline true\
	-font -*-$family-Bold-R-Normal--*-240-*-*-*-*-*-*

proc Intext {txt {tgs {norm}} } {
 global w
 $w.frame.mess insert end $txt $tgs
}

Intext "UNIX/Linux ABACUS\n\n" verybigblue

Intext "Hello everyone, this is just a bit of information about ABACUS.\
 ABACUS runs under Linux, the free Un*x operating system found on a large number\
 of Internet servers around the world. \n\nThe minimal hardware requirements are an IBM\
 compatible 386 machine or better with at least 4 Mb RAM (preferably at least 8 Mb).\
 A harddisk with 30Mb has been used\
 although >200Mb is required for the display system (X). On a network (ethernet or\
 even serial) a diskless system should be possible, although this cannot be\
 considered a secure arrangement.\n\n"
 
Intext "Process I/O can be achieved using DAS08, DAS16 EISA bus cards, the Bristol Babcock PI-Bus\
 system, the Bristol Babcock BSAP driven process control systems\
 or a number of remote serial bus driven systems.\n\n"

Intext "Since the Operating system is completely TCP/IP compatible any number of\
 systems can be connected together via a wide range of network hardware. Connection\
 over existing networks that support TCP/IP (and others), and even over The Internet
 are supported.\n\n"

Intext "Operator access is controlled by the normal UN*X password protection regimes.\n\n"

Intext "This display and the others available in this demonstration are\
 constructed using the Tcl/Tk languages. These have the advantage that\
 they are freely available for Windows95, UNIX, Macintosh, Windows3.1 (etc)\
 and WindowsNT\n\n"

Intext "This "
Intext "tk-demo" xx0
$w.frame.mess tag bind xx0 <1> {exec /usr/lib/tk4.1/demos/widget &}

Intext " button starts an interesting demonstration of tk widgets.\
 \n\n"



Intext "\nThe ABACUS demonstration on this machine\n\n" bigcenter
Intext "This ABACUS system has a demonstration of a pumpstation\
 control system loaded.\n\nThe pumpstation has three pumps pumping from a\
 sump, with an uncontrolled incomming flow. When the level in the sump rises over "
Intext "Startniv 1" bold
Intext " one pump is started. Should the level exceed "
Intext "Startniv 2" bold
Intext " a second pump is started. "
Intext "Startniv 3" bold
Intext " will cause all three to be started if it is ever exceeded.\n"

Intext "\nWhen the level goes below "
Intext "Stopniv 3" bold
Intext " any third pump is stopped. Below "
Intext "Stopniv 2" bold
Intext " will stop the second pump, and "
Intext "Stopniv 1" bold
Intext " will stop all three pumps.\n"

Intext "\nIn order to spread the run times over all three pumps\
 they are alternated. The pump to be used first has a "
Intext "rank" bold
Intext " of 1. The second "
Intext "rank" bold
Intext " 2, and the third "
Intext "rank" bold
Intext " 3.\n\nThe rank values are alterated each time all\
 three pumps are stopped.\n\n"
Intext "The operator may run the pumps without alternating them.\
 In order to do this he presses the "
Intext "ALTERNERA" bold
Intext " (sorry about the Swedish) button, which then becomes\
 red.\n\nHe may even run the pump in hand."



Intext "\n\nTHE ABACUS LANGUAGE\n\n" bigcenter
Intext "The VAX ABACUS manual exists in HTML format on this machine. You may wish to\
 look at it by pressing "
Intext "here." xx5
$w.frame.mess tag bind xx5 <1> { toplevel .msg
	message .msg.msg -text "Netscape should start soon, please wait! \
	\n\n\This message will self-destuct in 5 seconds."  \
	-justify center -foreground blue -font \
	-*-Helvetica-Bold-R-Normal--*-240-*-*-*-*-*-*
	pack .msg.msg
	exec netscape -ncols 16 /home/abacus/manual/index.html &
	after 5000 {catch {destroy .msg}}
	}



Intext "\n\nDISPLAYS\n\n" bigcenter
Intext "The displays may be started by pressing the buttons\
 on the "
Intext "Abacus picture selector " bold
Intext "display, when you have closed this display.\
 If you wish to see the code for the pumpstation mimic display the file is\
 called "

Intext "pump21.sh" xx1
$w.frame.mess tag bind xx1 <1> {exec nedit -read /home/abacus/pump21.sh}
Intext " The background image is called "
Intext "pump23.gif" xx2
$w.frame.mess tag bind xx2 <1> {exec xv  -wait 10 /home/abacus/pump23.gif}
Intext "\n\nThe DATA PAGE and JOURNAL are executed in "
Intext "xterm " bold
Intext "windows. If you wish to edit the source file for the DATA PAGE press "
Intext "here" xx3
$w.frame.mess tag bind xx3 <1> {exec nedit /home/abacus/ftest.fmt }
Intext ". The editor is called NEDIT, and is rather good. Check out\
 the help menus.\n\n"
 


Intext "\n\nX windows system and ABACUS Displays\n\n" bigcenter

Intext "When you press a button on the main "
Intext "Abacus picture selector " bold
Intext "window you start a new process. "
Intext "This process usually runs without blocking the process\
 which started it. This means that a large number of processes can run at the\
 same time. If there is much dynamic information on these displays system loading\
 is affected if the number of open displays is great.\n\n"
Intext "If you press the top part of a window\
 with the right hand mouse button, it will go to the back. This feature\
 is not available with Windows95 etc. \n\n"


Intext "\n\nTo close this page, and return to the\
 'Abacus picture starter' just press the 'close-window' button top right of this window.\
 \n\nThis should work on any of the displays.\n" big

Intext "\nEdit this file by pressing "
Intext "here" xx4
Intext "."
$w.frame.mess tag bind xx4 <1> {exec nedit /home/abacus/abainfo.sh & }


foreach xx {xx0 xx1 xx2 xx3 xx4 xx5} {
	$w.frame.mess tag configure $xx -foreground blue -underline on 
	$w.frame.mess tag bind $xx <Any-Enter> "$w.frame.mess configure -cursor hand2"
	$w.frame.mess tag bind $xx <Any-Leave> "$w.frame.mess configure -cursor xterm"
}


bind . <Control-c> {destroy .}
bind . <Control-C> {destroy .}
