#!/bin/sh
# linuxinfo.sh - Linux information
# the next line restarts using wish \
exec wish "$0" "$@" -geometry +0+0

# Edit this by all means, but be careful of syntax!
# A '#' starts a comment
# A \ at the end of a line is a continuation, miss it out at your own risk!
# quite marks much match each other. etc. etc.
# If you do an edit, try it out frequently. Tcl/tk throughs up an error window
# if it can't understand something; you then can chose to see a stack listing, which might
# be of some help!


#-geometry +0+550

set bold "-background #43ce80 -relief raised -borderwidth 1"
set normal "-background {} -relief flat"

set w .page
wm title . [format "Linux Information" ]

#image create photo Pic

frame $w 
frame $w.frame
pack $w $w.frame
text $w.frame.mess  -wrap word  -width 80 -height 24  -setgrid true \
-yscrollcommand "$w.frame.s set"
scrollbar $w.frame.s -orient vert -command "$w.frame.mess yview"
pack $w.frame.s -side right -fill y
pack $w.frame.mess -side left -fill both -expand true

set family Courier
set family helvetica

$w.frame.mess tag configure norm 	-font -*-$family-medium-R-Normal--*-120-*-*-*-*-*-*
$w.frame.mess tag configure bold 	-font -*-$family-Bold-R-Normal--*-120-*-*-*-*-*-*
$w.frame.mess tag configure big 	-font -*-$family-Bold-R-Normal--*-140-*-*-*-*-*-*
$w.frame.mess tag configure bigcenter 	-justify center  -underline true\
	-font -*-$family-Bold-R-Normal--*-140-*-*-*-*-*-*
$w.frame.mess tag configure verybigblue -justify center -foreground blue -underline true\
	-font -*-$family-Bold-R-Normal--*-240-*-*-*-*-*-*

proc Intext {txt {tgs {norm}} } {
 global w
 $w.frame.mess insert end $txt $tgs
}

set tfile [open "/home/abacus/Linux.txt" r]
set contents [read $tfile]
Intext $contents



bind . <Control-c> {destroy .}
bind . <Control-C> {destroy .}
