#!/bin/sh
# /home/abacus/C2/alarm_banner.sh - ABACUS alarm banner 
# the next line restarts using wish \
exec wish "$0" "$@"
# -geometry 90x20+0+453

set NODE	localhost

########################################################################
#
# ORCOL ALARM BANNER
#
# Initial version 980407
########################################################################
cd /home/abacus/
set w .page
############## TITLE set here ##########################################
wm title . [format "CURRENT ALARMS - ABACUS4 " ]
#####wm geometry . 640x240+0+0
#####wm geometry . 640x240+0+473
#wm geometry . 640x480+0+0
wm resizable . 0 0

##################### bash-net substitute ############################

catch { unset sock  }

proc BashNetReader { sock } {
    global BashNetforever BashNetReaderResult
    gets $sock line
    if { $line == "e17971e17971" } {
      set BashNetforever 1
      return line
    }
    append BashNetReaderResult "$line\n"
    return line
}

proc BashNet { node_ args } {
    global BashNetforever BashNetReaderResult sock

    set BashNetReaderResult ""
    if { [info exists sock] == 0 } then { 
        set sock [socket $node_ 9000]
        fconfigure $sock -blocking 1 -buffering line -translation lf 
     }
    puts $sock "[lrange $args 0 end];echo e17971e17971;"
    flush $sock

    fileevent $sock readable [list BashNetReader $sock]
    vwait BashNetforever
    return $BashNetReaderResult
}

proc wasBashNet { sock args } {
  return [exec /home/abacus/bashnet $sock $args]
}
##################### End of bash-net substitute ############################


frame $w 
frame $w.frame
pack $w $w.frame
text $w.frame.mess  -wrap word  -width 90 -height 15  -setgrid true -yscrollcommand "$w.frame.s set"
scrollbar $w.frame.s -orient vert -command "$w.frame.mess yview"
pack $w.frame.s -side right -fill y

frame $w.menu -relief raised -bd 2

############## X/Y display stuff defined here ################################

button $w.menu.xycont  -borderwidth 0 -width 32
bind .  <Motion> {    #$w.menu.xycont delete 0 end
		      set blkno_ [$w.frame.mess get "current linestart + 22 chars" "current linestart + 53 chars" ]
		      #set blkno_2 [format "ack: %%-35.35s" $blkno_]
		      $w.menu.xycont configure -text "$blkno_"
		      set destination_display {}
		       }
bind . 	<Leave>	{ $w.menu.xycont configure -text {} }
		       
############## Time/Date stuff defined here ################################
button $w.menu.timdat -borderwidth 0 -width 40 -justify right
 
proc timdat {} {	global w blkno_2 NODE
			catch { $w.menu.timdat configure -text [exec  date "+%A %d-%B-%Y %H:%M:%S"] }
			catch { after cancel timdat }
			after 1000 timdat
			}

timdat

############## Menu stuff defined here ################################
set m $w.menu.file.m
menubutton $w.menu.file -text "  ACKNOWLEDGE  " -menu $m
menu $m -tearoff 0
#$m add separator
#$m add command -label "" -command { bell }
$m add command -label "Acknowledge all" -command {ack_all}
$m add command -label "Acknowledge newest" -command {ack_newest}
# -underline 0
$m add command -label "" -command {  }

set m $w.menu.restart.m
menubutton $w.menu.restart -text "Restart" -menu $m
menu $m -tearoff 0
#$m add command -label "" -command { bell }
$m add command -label "restart" -command { exec /home/abacus/C2/alarm_banner.sh &; exit }
$m add command -label "" -command {  }


pack $w.menu -side top -fill x
pack $w.menu.file  -side left
#pack $w.menu.restart $w.menu.xycont $w.menu.timdat  -side left
pack $w.menu.xycont $w.menu.timdat  -side left
pack $w.frame.mess -side left -fill both -expand true

set family helvetica
set family Courier

proc ack_all {} {
	global w NODE
	for {set i 1} {$i < 20} {incr i 1} {
	set blkno_ [$w.frame.mess get $i.23 $i.29 ]
	set blkno [expr $blkno_ + 0]
#	puts stdout $blkno
	BashNet $NODE  /home/abacus/eng2 b$blkno,con,ama
	}
	
}
proc ack_newest {} {
	global w NODE
	set i 1
	set blkno_ [$w.frame.mess get $i.23 $i.29 ]
	set blkno [expr $blkno_ + 0]
#	puts stdout "BashNet $NODE  /home/abacus/eng2 b$blkno,con,ama"
	BashNet $NODE  /home/abacus/eng2 b$blkno,con,ama
}


$w.frame.mess tag configure normblack 	-font -*-$family-medium-R-Normal--*-120-*-*-*-*-*-* -foreground white -background gray
$w.frame.mess tag configure alarmred 	-font -*-$family-medium-R-Normal--*-120-*-*-*-*-*-* -foreground white -background red
$w.frame.mess tag configure alarmblue 	-font -*-$family-medium-R-Normal--*-120-*-*-*-*-*-* -foreground white -background blue
$w.frame.mess tag configure alarmyellow 	-font -*-$family-medium-R-Normal--*-120-*-*-*-*-*-* -foreground black -background yellow
$w.frame.mess tag configure alarmgray 	-font -*-$family-medium-R-Normal--*-120-*-*-*-*-*-* -foreground white -background gray
$w.frame.mess tag configure norm 	-font -*-$family-medium-R-Normal--*-120-*-*-*-*-*-*
$w.frame.mess tag configure bold 	-font -*-$family-Bold-R-Normal--*-120-*-*-*-*-*-*
$w.frame.mess tag configure big 	-font -*-$family-Bold-R-Normal--*-140-*-*-*-*-*-*
$w.frame.mess tag configure bigcenter 	-justify center  -underline true\
	-font -*-$family-Bold-R-Normal--*-140-*-*-*-*-*-*
$w.frame.mess tag configure verybigblue -justify center -foreground blue -underline true\
	-font -*-$family-Bold-R-Normal--*-240-*-*-*-*-*-*

proc Intext {txt {tgs {norm}} } {
 global w NODE
 $w.frame.mess insert end $txt $tgs
}

#Intext "[exec /home/abacus/acb-alarms.sh ] \n" alarmred
set flasher 0

$w.frame.mess configure -cursor sb_left_arrow
bind $w.frame.mess <1> { 
 set blkno_ [$w.frame.mess get "current linestart + 23 chars" "current linestart + 29 chars" ]
 set blkno [expr $blkno_ + 0]
puts stdout "exec /home/abacus/bashnet $NODE  /home/abacus/eng2 b$blkno,con,ama"
 BashNet $NODE  /home/abacus/eng2 b$blkno,con,ama
  }
#bind $w.frame.mess <3> { exec /home/abacus/C2/alarm_banner.sh &; exit }

proc update_ {} {
	global w flasher NODE
	
	if { [winfo viewable .] } {
		set scrollpos [$w.frame.mess yview]
		set scrollpos2 [lrange $scrollpos 0 0]
		if { [lrange $scrollpos 0 0] == 0 } {
		  $w.frame.s configure -background darkgreen
		  wm title . [format "CURRENT ALARMS - ABACUS4 " ]
		} else {
		  $w.frame.s configure -background darkred
		  wm title . [format "CURRENT ALARMS - ABACUS4 (LATEST ALARM NOT VISIBLE!!)" ]
		}
	# puts stdout "\[lrange \$scrollpos 0 0\] [lrange $scrollpos 0 0]"
 		$w.frame.mess configure -state normal
		
		#set mess [BashNet $NODE  /home/abacus/alarm -nobsap | grep -v ^\[AU\]\[04-9\] | sort +0.0r -0.1r +0.1 -0.2 +1.0r " \n" ]
		set mess0 [BashNet $NODE  /home/abacus/alarm -nobsap  | sort +0.0r -0.1r +0.1 -0.2 +1.0r ]
		set mess ""
		foreach x [split $mess0 "\n"] { if ![regexp {^.[04-9]} $x] { append mess "$x\n" } }
		
		$w.frame.mess delete 1.0 end
		
		$w.frame.mess insert end $mess normblack
		
		$w.frame.mess yview moveto $scrollpos2
		set scrollpos [$w.frame.mess yview]

		for {set i 1} {$i < 121} {incr i 1} {
		   set j [expr $i + 1]
		   if {[$w.frame.mess dump -text $i.1] == "text 1 $i.1"} { $w.frame.mess tag add alarmred   $i.0 $j.0 }
		   if {[$w.frame.mess dump -text $i.1] == "text 2 $i.1"} { $w.frame.mess tag add alarmblue  $i.0 $j.0 }
		   if {[$w.frame.mess dump -text $i.1] == "text 3 $i.1"} { $w.frame.mess tag add alarmyellow $i.0 $j.0 }
		   if {[$w.frame.mess dump -text $i.1] == "text 4 $i.1"} { $w.frame.mess tag add alarmgray  $i.0 $j.0 }
		}

		if {$flasher == 0} {
			set flasher 1
			for {set i 1} {$i < 121} {incr i 1} {
			   if {[$w.frame.mess dump -text $i.0] == "text U $i.0"} {
				$w.frame.mess delete $i.53 $i.end
				############ 
				##bell
				 }

			}
		} else {
			set flasher 0
		}

		$w.frame.mess configure -state disabled
	  }
	after 1000 update_
  }
update_
#/home/abacus/alarm -nobsap | sort -r | head -n 5 | cut -c1-20,26-90

