#!/bin/sh
# ./display.sh  - ABACUS operator interface 
# the next line restarts using wish \
exec wish "$0" "$@" -geometry +0+0
########################################################################
#
# Simulation 
#
# Initial version 990603
# 
# 
########################################################################

####### Edit this bit, because there should bot be any more direct
####### path references refering to the local machine.
#cd /home/abacus/
set w .page

set NODE	localhost

############## TITLE set here ##########################################
#
wm title . [format "ABACUS4 Display Manager - Teachers ABACUS" ]
wm resizable . 0 0

############## BACKGROUND IMAGES DONE HERE ######
frame $w 
canvas $w.p -height 425 -width 630 
frame $w.menu -relief raised -bd 2
label $w.welcome -text "THE DISPLAY SYSTEM IS STARTING PLEASE WAIT"
pack $w $w.menu $w.p  $w.welcome  -side top -fill x
update idletasks

############## GIF Files defined here ###################################

# valves pumps and blobs
foreach blob { 
 vent_t_green	vent_t_gray	vent_t_red  
 vent_r_green	vent_r_gray	vent_r_red  
 vent_l_green	vent_l_gray	vent_l_red  
 pump_u_green	pump_u_gray	pump_u_red
 pump_d_green	pump_d_gray	pump_d_red
 pump_l_green	 pump_l_gray	pump_l_red	
 pump_r_green	pump_r_gray	pump_r_red
 blob_green	blob_gray	blob_red   
 fan_u_gray	fan_u_green	fan_u_red
 fan_d_gray	fan_d_green	fan_d_red
 LEFTFLAME	NOLEFTFLAME	NORIGHTFLAME RIGHTFLAME
 reel
} {
$w.welcome configure -text "doing $blob"
update idletasks
image create photo $blob  -file   ./$blob.gif
}
$w.welcome configure -text "done the vent & pumps"
update idletasks

# Data pages
#image create photo Pic_opcodes -file   ./opcodes.gif
image create photo Pic_dp3 -file   ./datapage_3.gif
image create photo Pic_dp2 -file   ./datapage_2.gif
image create photo Pic_dp1 -file   ./datapage_1.gif
$w.welcome configure -text "done the datapage images"
update idletasks

# Mimic pages
foreach nr {1 2 3 4 5} {
$w.welcome configure -text "starting ./process_$nr.gif"
update idletasks
catch { image create photo Pic_mp$nr -file   ./process_$nr.gif}
}

$w.welcome configure -text "done the mimic images"
update idletasks

image create photo Pic
$w.p create image 0 0 -image Pic -anchor nw


############################################################################

#cd /home/abacus/
if { [info exists NODE] } {
  
  } else {
    set NODE localhost
  }
############## Symbols defined here ####################################
##
## Create an image for each symbol file that is in the directory

#foreach fil [ glob /home/abacus/shapes-ppm/*.ppm ] {
## catch { foreach fil [ glob /home/abacus/shapes/*.ppm ] {
## 	catch { set pic [file rootname [file tail $fil]] }
## 	catch { image create photo $pic }
## 	catch { $pic configure -file $fil }
## 
## 	catch { image create photo ${pic}_black -palette 3 }
## 	catch { ${pic}_black configure -file $fil }
## } }


##################### bash-net substitute ############################

proc BashNetReader { sock } {
  global BashNetforever BashNetReaderResult
  gets $sock line
  if { $line == "e17971e17971" } {
    set BashNetforever 1
    catch {close $sock}
#puts stdout "BashNetReader: close $sock"
    catch {close $sock}
    return line
  }
  append BashNetReaderResult "$line\n"
  return line
}

proc BashNet { sock args } {
  global BashNetforever BashNetReaderResult

    set BashNetReaderResult ""
    set sock [socket $sock 9000]
#puts stdout "BashNet: set sock \[socket $sock 9000\]" 
    fconfigure $sock -blocking 1 -buffering line -translation lf 
    puts $sock "[lrange $args 0 end];echo e17971e17971;"
    flush $sock

    fileevent $sock readable [list BashNetReader $sock]
    vwait BashNetforever
    return $BashNetReaderResult
}


############## Menu stuff defined here ################################
#frame $w.menu -relief raised -bd 2

set m $w.menu.file.m
menubutton $w.menu.file -text "DISPLAY" -menu $m -underline 0
menu $m -tearoff 0
proc clearup {} {
  global w xx
  foreach xx [split [after info] " "] { after cancel $xx }
  foreach xx [winfo children $w.p] { destroy $xx }
 }

proc change_to_org { the_page } {
  global w xx the_page_

  $w.p configure -height 425 -width 630 
  set the_page_ $the_page
  foreach i  [array names bar] { unset bar($i) }
  foreach xx [split [after info] " "] { after cancel $xx }
  foreach xx [winfo children $w.p] { destroy $xx }
  catch { uplevel #0 { source ./${the_page_}.tcl } }
  catch { update0 }
  timdat
 }

proc change_to { the_page } {
  global w xx the_page_ bar

#  $w.p configure -width 630 -height 425 
  set the_page_ $the_page
  foreach i  [array names bar] { unset bar($i) }
  foreach xx [split [after info] " "] { after cancel $xx }

  destroy $w.p 
  canvas $w.p -width 630 -height 425

  $w.p create image 0 0 -image Pic -anchor nw
  pack $w $w.menu $w.p -side top -fill x

  catch { uplevel #0 { source ./${the_page_}.tcl } }
#  catch { update0 }
  timdat
 }

proc mem_test {} {
  #set self [open /proc/self/status r]
  #puts stdout "[read $self]"
  #close $self
  #puts stdout "info cmdcount [info cmdcount]"
}



## $m add separator
## $m add command -label "C2_1   Vllkomstbild" -command { 
## 	clearup
## 	catch { source ./C2_1.tcl }
##   } 
## $m add separator
## $m add command -label "Data Page 1 " -command { change_to dp1 }
## $m add command -label "Data Page 2 " -command { change_to dp2 }
## $m add command -label "Data Page 3 " -command { change_to dp3 }
## $m add separator
## $m add command -label "Reel Report " -command { change_to reel }
## $m add separator
$m add command -label "Mimic 1 Machine Overview" -command { change_to mp1 }
$m add command -label "Mimic 2 Machine Overview and PIDs" -command { change_to mp2 }
## $m add command -label "Mimic 3 " -command { change_to mp3 }
## $m add command -label "Mimic 4 " -command { change_to mp4 }
## $m add command -label "Mimic 5 " -command { change_to mp5 }
$m add separator

$m add command -label "Trend display" -command {
 catch { exec  ./trend.sh & } }

$m add separator

$m add command -label "Full Journal" -command { 
 catch { exec  ./kill.journal.sh }
 exec nice ./journal_updating.sh { } &
    }
   
$m add command -label "Alarm Journal" -command { 
 catch { exec  ./kill.journal.sh }
 exec nice ./journal_updating-2.sh { } &
    }
   
$m add command -label "Alarm display" -command {
 catch { exec  ./kill.alarm_banner.sh }
 exec ./alarm_banner.sh & }


set m $w.menu.file2.m
menubutton $w.menu.file2 -text "DISPLAYS 2 " -menu $m -underline 0
menu $m -tearoff 0

$m add command -label "phtrend1" -command {phtrend1} 
$m add separator
$m add command -label "Start a new Engineers Mode" -command { exec xterm -e /home/abacus/bashnet $NODE /home/abacus/eng & } -underline 0
$m add separator



########## Start other displays with these routines ##########
proc start_abapic {} {\
	global NODE
	catch { exec ./kill.abapic.sh }
	catch { exec nice ./abapic.sh  -geometry +0+0 & }
	after 1000 exit
	}


proc C2_1 {} {\
	global NODE
	foreach xx [split [after info] " "] { after cancel $xx }
	exec nice ./C2_1.sh  -geometry +0+0 &
	after 1000 exit
	}

proc C2_tvatsek_1 {} {\
	global NODE
	exec nice ./C2_tvttsekvens_1.sh  -geometry +0+0 &
	}

proc jump_button { name  x  y  text } {
	global NODE
  global	w lfont bg fg 
##   button  $w.p.ti$name -font $lfont -background $bg -foreground $fg \
##     -activebackground $bg -activeforeground $fg \
##      -pady 0 -padx 3 -relief flat -borderwidth 0 -text $text -command $name
  button  $w.p.ti$name -text $text -command $name -pady 0 -padx 0
  place $w.p.ti$name -x $x -y $y -anchor sw
  }

#proc bgerror { message } { 
#  bell
#}


############## Blinking stuff ########################
set fulltime	1000
set fulltime	500
set blinkon 0
proc blink_change { } {
	global NODE
	global blinkon fulltime
	after cancel blink_change
	if { $blinkon  } then {
		set blinkon 0
		} else {
		set blinkon 1
		}
#	after $fulltime blink_change
}
##blink_change

############## Time/Date stuff defined here ################################
button $w.menu.timdat -borderwidth 0 -width 20 -justify right
 
proc timdat {} {
	global w blinkon fulltime
	global NODE
	catch { $w.menu.timdat configure -text [clock format [clock seconds] -format "%Y-%m-%d %H:%M:%S" ] }
	catch { after cancel timdat }
	mem_test
	blink_change
	after $fulltime  timdat
	}

############## X/Y display stuff defined here ################################

#button $w.menu.xycontb  -borderwidth 0 -width 15 -command bell
button $w.menu.xycontb  -borderwidth 0 -width 25 -command bell

proc show_time { time_taken } {
	global NODE
  global w smoothed_time  
  
  set mili_secs [ expr [lindex $time_taken 0] / 1000]
##   set smoothing_factor 0.80
##   if { [info exists smoothed_time] == 0 } then {
     set smoothed_time $mili_secs
##     } else {
##     set new_smoothed_time [expr ( $smoothed_time * $smoothing_factor ) + \
##     	$mili_secs * ( 1.0 - $smoothing_factor ) ]
##     set smoothed_time $new_smoothed_time
##     }
  
  ## get newest unack alarm if there is one
  set alarm_1 "[BashNet $NODE  /home/abacus/alarm | sort -r | head -1 ]"

  if { [string index $alarm_1 0] == "U" } then {
      $w.menu.xycontb configure -text [string range $alarm_1 28 52] \
       -background red -activebackground red
    } else {
      $w.menu.xycontb configure -text [format "%5.0f mS" $smoothed_time ] \
       -background grey85 -activebackground grey95
    }


  }


entry $w.menu.xycont  -borderwidth 0 -width 15
##$w.menu.xycont insert end "Very new pumps proc !"
bind .  <Motion> {   $w.menu.xycont delete 0 end
		     $w.menu.xycont insert end "x = %x y = %y"
		     set destination_display {}
		      }

############## X/Y display button 3 puts text available for copying ################################
button $w.menu.xy3b -width 25 -borderwidth 0 -command bell
entry $w.menu.xy3 -width 20 -borderwidth 0
bind .  <3> {  $w.menu.xy3 delete 0 end
		       $w.menu.xy3 insert end "-x %x -y %y %x %y" }
bind .  <2> {  $w.menu.xy3 delete 0 end }
$w.menu.xy3b configure -text "([clock format [clock seconds] -format "%Y-%m-%d %H:%M" ])"

			
############## This stuff puts the above defined stuff on the screen ##########
#pack $w $w.menu $w.p   -side top -fill x
######## Choose between the following for the x/y coordinate display ####
#pack $w.menu.file $w.menu.special $w.menu.xycont $w.menu.xy3  $w.menu.timdat -side left
#pack $w.menu.file $w.menu.xycont $w.menu.xy3  $w.menu.timdat -side left
#pack $w.menu.file $w.menu.xycontb $w.menu.xycont $w.menu.xy3  $w.menu.timdat -side left
#pack $w.menu.file $w.menu.xycontb $w.menu.timdat -side left
pack $w.menu.file $w.menu.xycontb $w.menu.xy3  $w.menu.timdat -side left

###pack $w.menu.file $w.menu.special $w.menu.xycontb $w.menu.xy3b  $w.menu.timdat -side left
##pack $w.menu.file $w.menu.xy3b  $w.menu.timdat -side left

pack $w $w.p -side top
update idletasks

timdat

############## Set font and colour variables ################################## 
set bg	black
set fg	yellow

set bg	white
set fg	black

set lfont  -adobe-helvetica-medium-r-*-*-10-*-*-*-*-*-*-*
set lfont  -adobe-helvetica-medium-r-*-*-8-*-*-*-*-*-*-*
set lfont  "-windows-small fonts-medium-r-normal-*-*-100-*-*-p-*-ansi-*"
set lfont  -*-clean-medium-r-normal--8-*-*-*-*-*-*-*
set lfont  -adobe-courier-medium-r-*-*-10-*-*-*-*-*-*-*
set lfont {courier 10 normal}

############## Entry stuff defined here ################################

set logged_in 0
proc log_in {} {
  global NODE logged_in
  
}

proc update_face { } {
 global NODE
 global w blkno typestr_
 global bnoMV_ bnoSP_ bnoOU_ bnoMAN_ bnoAM_
 global MV_ SP_ OU_ MAN_ AM_ AM_STR
  
 catch { set MV_ [ra $bnoMV_] }
 catch { set SP_ [ra $bnoSP_] }
 catch { set OU_ [ra $bnoOU_] }
 catch { set MAN_ [ra $bnoMAN_] }
 catch { set AM_ [vn $bnoAM_] }
 catch { if { $AM_ } { set AM_STR "STATUS: AUTO" } else { set AM_STR "STATUS: HAND" } }
 catch { $w.face.am configure -text $AM_STR }

# catch { if { !$AM_ } { $w.face.auto configure -state disabled } else { $w.face.auto configure -state normal } }
# catch { if { !$AM_ } { $w.face.hand configure -state normal } else { $w.face.hand configure -state disabled } }
 after 500 update_face
}

set bnoMV_ 0
set bnoSP_ 0
set bnoOU_ 0
set bnoAM_ 0
set MV_ 0
set SP_ 0
set OU_ 0
set AM_ 0
#update_face

proc setval { blockno  value } {
 global NODE
 global w 
 global bnoMV_ bnoSP_ bnoOU_ bnoAM_
 global MV_ SP_ OU_ AM_ AM_STR doit
 if { $doit } {
    BashNet $NODE  /home/abacus/eng2 b$blockno,con,dd777,ra$value
 }
}

proc face_plate { bnoMV bnoSP bnoOU bnoMAN bnoAM max min resol title_ str  } {
 global NODE
 global w blkno typestr_
 global bnoMV_ bnoSP_ bnoOU_ bnoMAN_ bnoAM_
 global MV_ SP_ OU_ MAN_ AM_ AM_STR doit
 
 
 set bnoMV_    $bnoMV
 set bnoSP_    $bnoSP
 set bnoOU_    $bnoOU
 set bnoMAN_   $bnoMAN
 set bnoAM_    $bnoAM
 
 if { $bnoOU_ } { set OU_state normal } else { set OU_state disabled }
 if { $bnoMAN_ } { set MAN_state normal } else { set MAN_state disabled }
 
#	after 50 { wm geometry $w.face +[winfo pointerx .]+[winfo pointery .] }
	catch { destroy $w.face } ; toplevel $w.face 
	wm title $w.face $title_
	wm geometry $w.face +50+50
#
	update idletasks
	after cancel update_face
	
	#grab -global $w.face
	label  $w.face.label -text [format "%s" $str ]
	label  $w.face.max   -text [format "%7.1f" $max]
	label  $w.face.min   -text [format "%7.1f" $min]
	label  $w.face.mv  -text "MV"
	label  $w.face.sp  -text "SP"
	label  $w.face.ou  -text "OUT"
	label  $w.face.man  -text "HAND"
## 	set MV_ -999
## 	set SP_ -999
## 	set OU_ -999
	
	set doit 0
	after 100 { set doit 1 }
	
	scale $w.face.mvscale -from $max -to $min -length 200 -variable MV_ \
		-orient vertical -fg yellow -bg darkred -tickinterval [expr ( $max - $min ) / 4] \
		-resolution $resol
		
	scale $w.face.spscale -from $max -to $min -length 200 -variable SP_ \
		-orient vertical -fg yellow -bg darkblue -tickinterval [expr ( $max - $min ) / 4] \
		-command " setval  $bnoSP_ " \
		-resolution $resol

	scale $w.face.ouscale -from 100 -to 0 -length 200 -variable OU_ \
		-orient vertical -fg yellow -bg darkgreen -tickinterval 50 -state $OU_state \
		-resolution 1
	
	scale $w.face.manscale -from 100 -to 0 -length 200 -variable MAN_ \
		-orient vertical -fg yellow -bg darkgreen -tickinterval 0 -state $MAN_state \
		-command " setval  $bnoMAN_ "\
		-resolution 1
	
	button $w.face.auto -text "CHANGE TO: AUTO" -command "BashNet $NODE  /home/abacus/eng2 b$bnoAM,con,ama"
	button $w.face.hand -text "CHANGE TO: HAND" -command "BashNet $NODE  /home/abacus/eng2 b$bnoAM,con,amm"
	button $w.face.am   -text ""


	grid $w.face.label    -row 1 -column 0 -columnspan 3 
#	grid $w.face.max      -row 2 -column 0
#	grid $w.face.min      -row 2 -column 1
	grid $w.face.mv       -row 3 -column 0
	grid $w.face.sp       -row 3 -column 1

	if { $bnoOU_ != 0 } { 
	  grid $w.face.ou       -row 3 -column 2
	  grid $w.face.ouscale  -row 4 -column 2 -rowspan 3
	  }

	if { $bnoMAN_ != 0 } { 
	  grid $w.face.man       -row 3 -column 3
	  grid $w.face.manscale  -row 4 -column 3 -rowspan 3
	  }

	grid $w.face.mvscale  -row 4 -column 0 -rowspan 3
	grid $w.face.spscale  -row 4 -column 1 -rowspan 3
	grid $w.face.auto     -row 4 -column 4
	grid $w.face.am       -row 5 -column 4
	grid $w.face.hand     -row 6 -column 4
	
	update_face
	
##	bind $w.face <Return> {	BashNet $NODE /home/abacus/eng2 b$blkno,con,ra[$w.face.e1 get]
##			destroy $w.face }
##	bind $w.face <KP_Enter> {	BashNet $NODE /home/abacus/eng2 b$blkno,con,ra[$w.face.e1 get]
##			destroy $w.face }
}


proc face_plate_no_ha { bnoMV bnoSP bnoOU bnoMAN bnoAM max min resol title_ str  } {
 global NODE
 global w blkno typestr_
 global bnoMV_ bnoSP_ bnoOU_ bnoMAN_ bnoAM_
 global MV_ SP_ OU_ MAN_ AM_ AM_STR doit
 
 
 set bnoMV_    $bnoMV
 set bnoSP_    $bnoSP
 set bnoOU_    $bnoOU
 set bnoMAN_   $bnoMAN
 set bnoAM_    $bnoAM
 
 if { $bnoOU_ } { set OU_state normal } else { set OU_state disabled }
 if { $bnoMAN_ } { set MAN_state normal } else { set MAN_state disabled }
 
#	after 50 { wm geometry $w.face +[winfo pointerx .]+[winfo pointery .] }
	catch { destroy $w.face } ; toplevel $w.face 
	wm title $w.face $title_
	wm geometry $w.face +50+50
#
	update idletasks
	after cancel update_face
	
	#grab -global $w.face
	label  $w.face.label -text [format "%s" $str ]
	label  $w.face.max   -text [format "%7.1f" $max]
	label  $w.face.min   -text [format "%7.1f" $min]
	label  $w.face.mv  -text "MV"
	label  $w.face.sp  -text "SP"
	label  $w.face.ou  -text "OUT"
	label  $w.face.man  -text "HAND"
## 	set MV_ -999
## 	set SP_ -999
## 	set OU_ -999
	
	set doit 0
	after 100 { set doit 1 }
	
	scale $w.face.mvscale -from $max -to $min -length 200 -variable MV_ \
		-orient vertical -fg yellow -bg darkred -tickinterval [expr ( $max - $min ) / 4] \
		-resolution $resol
		
	scale $w.face.spscale -from $max -to $min -length 200 -variable SP_ \
		-orient vertical -fg yellow -bg darkblue -tickinterval [expr ( $max - $min ) / 4] \
		-command " setval  $bnoSP_ " \
		-resolution $resol

	scale $w.face.ouscale -from 100 -to 0 -length 200 -variable OU_ \
		-orient vertical -fg yellow -bg darkgreen -tickinterval 50 -state $OU_state \
		-resolution 1
	
	scale $w.face.manscale -from 100 -to 0 -length 200 -variable MAN_ \
		-orient vertical -fg yellow -bg darkgreen -tickinterval 0 -state $MAN_state \
		-command " setval  $bnoMAN_ "\
		-resolution 1
	
#	button $w.face.auto -text "CHANGE TO: AUTO" -command "BashNet $NODE  /home/abacus/eng2 b$bnoAM,con,dd777,ra0,amm"
#	button $w.face.hand -text "CHANGE TO: HAND" -command "BashNet $NODE  /home/abacus/eng2 b$bnoAM,con,dd777,ra1,ama"
#	button $w.face.am   -text ""


	grid $w.face.label    -row 1 -column 0 -columnspan 3 
#	grid $w.face.max      -row 2 -column 0
#	grid $w.face.min      -row 2 -column 1
	grid $w.face.mv       -row 3 -column 0
	grid $w.face.sp       -row 3 -column 1

	if { $bnoOU_ != 0 } { 
	  grid $w.face.ou       -row 3 -column 2
	  grid $w.face.ouscale  -row 4 -column 2 -rowspan 3
	  }

	if { $bnoMAN_ != 0 } { 
	  grid $w.face.man       -row 3 -column 3
	  grid $w.face.manscale  -row 4 -column 3 -rowspan 3
	  }

	grid $w.face.mvscale  -row 4 -column 0 -rowspan 3
	grid $w.face.spscale  -row 4 -column 1 -rowspan 3
#	grid $w.face.auto     -row 4 -column 4
#	grid $w.face.am       -row 5 -column 4
#	grid $w.face.hand     -row 6 -column 4
	
	update_face
	
##	bind $w.face <Return> {	BashNet $NODE /home/abacus/eng2 b$blkno,con,ra[$w.face.e1 get]
##			destroy $w.face }
##	bind $w.face <KP_Enter> {	BashNet $NODE /home/abacus/eng2 b$blkno,con,ra[$w.face.e1 get]
##			destroy $w.face }
}

proc entry_open_shut { bno acb digo } {
   global NODE
   global w blkno
      
   set blkno $bno   
   
   if { $acb > 8000 && $acb < 8999 } {
     set text_list [BashNet $NODE /home/abacus/eng2 b$acb,ur,hr,ma,mm,si]
     set ur [string range $text_list [expr [string first \nur $text_list] + 3] [expr [string first \nur $text_list] + 9]]
     set hr [string range $text_list [expr [string first \nhr $text_list] + 3] [expr [string first \nhr $text_list] + 9]]
     set ma [string range $text_list [expr [string first \nma $text_list] + 3] [expr [string first \nma $text_list] + 9]]
     set mm [string range $text_list [expr [string first \nmm $text_list] + 3] [expr [string first \nmm $text_list] + 9]]
     set si [string range $text_list [expr [string first \nsi $text_list] + 3] [expr [string first \nsi $text_list] + 34]]
     #after 50 { wm geometry $w.open +50+50 }
     after 50 { wm geometry $w.open +[winfo pointerx .]+[winfo pointery .] }
     catch { destroy $w.open }
     set ans [tk_dialog $w.open $si $si {} [vn $bno] $hr $ur "lt bli"]
     if { $ans == 0 } { BashNet $NODE /home/abacus/eng2 b$digo,con,amm }
     if { $ans == 1 } { BashNet $NODE /home/abacus/eng2 b$digo,con,ama }
   }

}

proc entry_kviterar { acb } {
   global NODE w
   
   if { $acb > 8000 && $acb < 8200 } {
     set ac [ac $acb] ; set vn [vn $acb] ; set si [si $acb] ; get_values ;
     set ac [ac $acb] ; set vn [vn $acb] ; set si [si $acb] ; get_values ;
     
     after 50 { wm geometry $w.open +[winfo pointerx .]+[winfo pointery .] }
     catch { destroy $w.open }
     set ans [tk_dialog $w.open $si $si {} $ac "lt bli" "KVITTERAR"]
     if { $ans == 1 } { BashNet $NODE /home/abacus/eng2 b$acb,con,ama }
     
   }

}

proc entry_error { message } {
	global w blkno
	after 50 { wm geometry $w.open +[winfo pointerx .]+[winfo pointery .] }
	catch { destroy $w.open }
	tk_dialog $w.open $message $message {} 0 "lt bli"
}

proc entry_stuff { bno str } {
	global NODE
	global w blkno
	
	set blkno $bno
	after 50 { wm geometry $w.new +[winfo pointerx .]+[winfo pointery .] }
	catch { destroy $w.new } ; toplevel $w.new 
	wm title $w.new $str
# This is like this to stop the operator clicking on some other place
# and leaving this entry stuff open
	update idletasks
	#grab -global $w.new
	button $w.new.b1 
	button $w.new.b3 
	$w.new.b1 configure -text "Cancel" -command {destroy $w.new}
	$w.new.b3 configure -text [format "Enter: %s" $str] \
	   -command {	BashNet $NODE /home/abacus/eng2 _$blkno\;con,dd777,ra[$w.new.e1 get]
			destroy $w.new }
	
	entry $w.new.e1
	$w.new.e1 insert end [ra $blkno]
	pack $w.new.e1 -side top
	pack $w.new.b3 $w.new.b1 -side left
	focus $w.new.e1
	bind $w.new <Return> {	BashNet $NODE /home/abacus/eng2 _$blkno\;con,ra[$w.new.e1 get]
			destroy $w.new }
	bind $w.new <KP_Enter> {	BashNet $NODE /home/abacus/eng2 _$blkno\;con,ra[$w.new.e1 get]
			destroy $w.new }
	}

proc entry_stuff_2 { bno title_ str } {
	global NODE
	global w blkno
	
	set blkno $bno
	after 50 { wm geometry $w.new +[winfo pointerx .]+[winfo pointery .] }
	catch { destroy $w.new } ; toplevel $w.new 
	wm title $w.new $title_
	wm geometry $w.new +50+50
#
	update idletasks
	#grab -global $w.new
	label $w.new.label -text $str
	button $w.new.b1 
	button $w.new.b3 
	$w.new.b1 configure -text "Cancel" -command {destroy $w.new}
	$w.new.b3 configure -text [format "ENTER: %s" ""] \
	   -command {	BashNet $NODE /home/abacus/eng2 b$blkno,con,ra[$w.new.e1 get]
			destroy $w.new }
	
	entry $w.new.e1
	$w.new.e1 insert end [BashNet $NODE /home/abacus/ra $blkno]
	pack $w.new.label $w.new.e1 -side top
	pack $w.new.b1 $w.new.b3 -side left
	focus $w.new.e1
	bind $w.new <Return> {	BashNet $NODE /home/abacus/eng2 b$blkno,con,ra[$w.new.e1 get]
			destroy $w.new }
	bind $w.new <KP_Enter> {	BashNet $NODE /home/abacus/eng2 b$blkno,con,ra[$w.new.e1 get]
			destroy $w.new }
	}



proc set_output { blk pcent } {
  global NODE
#  puts stdout "blk $blk pcent $pcent"
  BashNet $NODE /home/abacus/eng2 \'b$blk,con,ra$pcent,sp$pcent\'
}

proc entry_stuff_multi_ut { blk_acb blk_sp blk_hl blk_ll blk_ar blk_st blk_ut } {
	global NODE
	global w blkno out_val
	global str_ blk_acb_ blk_sp_ blk_hl_ blk_ll_ blk_ar_ blk_st_ mm blk_ut_ ma

	set blk_acb_ $blk_acb
	set blk_sp_ $blk_sp
	set blk_hl_ $blk_hl
	set blk_ll_ $blk_ll
	set blk_ar_ $blk_ar
	set blk_st_ $blk_st
	set blk_ut_ $blk_ut
	
	set eng4_pipe_multi [socket $NODE 9000]
	fconfigure $eng4_pipe_multi -buffering line
	puts $eng4_pipe_multi "/home/abacus/eng4 "

	puts $eng4_pipe_multi "si$blk_acb"
	catch { set str_ [gets $eng4_pipe_multi] }
	
	catch { destroy $w.new } ; toplevel $w.new 
	wm title $w.new "CHANGE $str_"
	wm geometry $w.new +50+50
#
	after 50 { wm geometry $w.new +[winfo pointerx .]+[winfo pointery .] }

	update idletasks
	#grab -global $w.new
	label $w.new.label -text $str_
	
	label  $w.new.spl -text "SETPOINT  "
	label  $w.new.hll -text "HIGH ALARM"
	label  $w.new.lll -text "LOW  ALARM"
	label  $w.new.utl -text "  OUTPUT  "

	puts $eng4_pipe_multi ra$blk_sp ;   gets $eng4_pipe_multi
	puts $eng4_pipe_multi hl$blk_hl ;   gets $eng4_pipe_multi
	puts $eng4_pipe_multi ll$blk_ll ;   gets $eng4_pipe_multi
	puts $eng4_pipe_multi ra$blk_ut ;   gets $eng4_pipe_multi

	puts $eng4_pipe_multi ra$blk_sp ; entry  $w.new.spe ; catch {$w.new.spe insert end [format "%g" [ gets $eng4_pipe_multi ]]}
	puts $eng4_pipe_multi hl$blk_hl ; entry  $w.new.hle ; catch {$w.new.hle insert end [format "%g" [ gets $eng4_pipe_multi ]]}
	puts $eng4_pipe_multi ll$blk_ll ; entry  $w.new.lle ; catch {$w.new.lle insert end [format "%g" [ gets $eng4_pipe_multi ]]}

	scale  $w.new.ute  -orient horizontal -length 200 -from 0 -to 100 \
			-tickinterval 20 -command "set_output $blk_ut " ;
	set out_val 50
	puts $eng4_pipe_multi ra$blk_ut ; set out_val [ gets $eng4_pipe_multi ] 
	$w.new.ute set $out_val 


	button $w.new.spb   -text [format "change SETPOINT  "]
	button $w.new.hlb   -text [format "change HIGH ALARM"]
	button $w.new.llb   -text [format "change LOW  ALARM"]

	label  $w.new.aml -text "AUTO/HAND"
	#set isauto [s2 $blk_acb_ ]
	puts $eng4_pipe_multi s2$blk_acb_ ; set isauto [ gets $eng4_pipe_multi ]
	
	label  $w.new.isauto -text "$isauto"
	puts $eng4_pipe_multi mm$blk_acb_ ; set mm [ gets $eng4_pipe_multi ]
	puts $eng4_pipe_multi ma$blk_acb_ ; set ma [ gets $eng4_pipe_multi ]


	button $w.new.rab   -text [format "RAISE"]
	button $w.new.lob   -text [format "LOWER"]

	$w.new.rab configure  -command { BashNet $NODE /home/abacus/eng2 b$blk_ut_,con,sp5 }
	$w.new.lob configure  -command { BashNet $NODE /home/abacus/eng2 b$blk_ut_,con,sp-5 }
	
	button $w.new.frab   -text [format "FAST RAISE"]
	button $w.new.flob   -text [format "FAST LOWER"]

	$w.new.frab configure  -command { BashNet $NODE /home/abacus/eng2 b$blk_ut_,con,sp20 }
	$w.new.flob configure  -command { BashNet $NODE /home/abacus/eng2 b$blk_ut_,con,sp-20 }
	
	$w.new.spb configure  -command { BashNet $NODE /home/abacus/eng2 b$blk_sp_,con,ra[$w.new.spe get];destroy $w.new }
	$w.new.hlb configure  -command { BashNet $NODE /home/abacus/eng2 \'b$blk_hl_,con,hl[$w.new.hle get]\';destroy $w.new }
	$w.new.llb configure  -command { BashNet $NODE /home/abacus/eng2 \'b$blk_ll_,con,ll[$w.new.lle get]\';destroy $w.new }


	button $w.new.ama -text "change to $ma" -command { BashNet $NODE /home/abacus/eng2 b$blk_ar_,con,ama ;destroy $w.new }
	button $w.new.amm -text "change to $mm" -command { BashNet $NODE /home/abacus/eng2 b$blk_ar_,con,amm ;destroy $w.new }
	button $w.new.amd -text "CLOSE" -command { destroy $w.new }
		
	grid $w.new.label  -row 0 -column 0 -rowspan 1 -columnspan 3 -sticky news
	if { $blk_sp_ } {
	   grid $w.new.spl -row 1 -column 0 -rowspan 1 -columnspan 1 -sticky news
	   grid $w.new.spe -row 1 -column 1 -rowspan 1 -columnspan 1 -sticky news
	   grid $w.new.spb -row 1 -column 2 -rowspan 1 -columnspan 1 -sticky news
	   }

	if { $blk_hl_ } {
	   grid $w.new.hll -row 2 -column 0 -rowspan 1 -columnspan 1 -sticky news
	   grid $w.new.hle -row 2 -column 1 -rowspan 1 -columnspan 1 -sticky news
	   grid $w.new.hlb -row 2 -column 2 -rowspan 1 -columnspan 1 -sticky news
	   }

	if { $blk_ll_ } {
	   grid $w.new.lll -row 3 -column 0 -rowspan 1 -columnspan 1 -sticky news
	   grid $w.new.lle -row 3 -column 1 -rowspan 1 -columnspan 1 -sticky news
	   grid $w.new.llb -row 3 -column 2 -rowspan 1 -columnspan 1 -sticky news
	   }

	if { $blk_ar_ } {
	   grid $w.new.aml -row 4 -column 0 -rowspan 1 -columnspan 1 -sticky news
	   grid $w.new.isauto -row 4 -column 1 -rowspan 1 -columnspan 1 -sticky news
	   if { [string trim $isauto] != [string trim $ma] } {
	       grid $w.new.ama -row 4 -column 2 -rowspan 1 -columnspan 1 -sticky news
	     } else {
	       grid $w.new.amm -row 4 -column 2 -rowspan 1 -columnspan 1 -sticky news
	     }
	   }

	if { $blk_ut_ } {
	   if { $blk_ut_ > 6300 } {	;# analog output
	      grid $w.new.utl -row 5 -column 0 -rowspan 1 -columnspan 1 -sticky news
	      grid $w.new.ute -row 5 -column 1 -rowspan 1 -columnspan 2 -sticky news
	      #grid $w.new.utb -row 5 -column 2 -rowspan 1 -columnspan 1 -sticky news
	      }
	   if { $blk_ut_ < 6300 } {	;# PDO
	      grid $w.new.utl -row 5 -column 0 -rowspan 1 -columnspan 1 -sticky news
	      grid $w.new.lob -row 5 -column 1 -rowspan 1 -columnspan 1 -sticky news
	      grid $w.new.rab -row 5 -column 2 -rowspan 1 -columnspan 1 -sticky news
	      grid $w.new.flob -row 6 -column 1 -rowspan 1 -columnspan 1 -sticky news
	      grid $w.new.frab -row 6 -column 2 -rowspan 1 -columnspan 1 -sticky news
	      }
	   }
	grid $w.new.amd -row 9 -column 2 -rowspan 1 -columnspan 1 -sticky news

	
	catch { close  $eng4_pipe_multi }

	}

proc entry_stuff_multi { str blk_acb blk_sp blk_hl blk_ll blk_ar blk_st } {
	global NODE
	global w blkno
	global str_ blk_acb_ blk_sp_ blk_hl_ blk_ll_ blk_ar_ blk_st_ mm ma
	
	set blk_acb_ $blk_acb
	set blk_sp_ $blk_sp
	set blk_hl_ $blk_hl
	set blk_ll_ $blk_ll
	set blk_ar_ $blk_ar
	set blk_st_ $blk_st
	
	set eng4_pipe_multi [socket $NODE 9000]
	fconfigure $eng4_pipe_multi -buffering line
	puts $eng4_pipe_multi "/home/abacus/eng4 "

	puts $eng4_pipe_multi "si$blk_acb"
	catch { set str_ [gets $eng4_pipe_multi] }
#	catch { set str_ $str }
	
	after 50 { wm geometry $w.new +[winfo pointerx .]+[winfo pointery .] }
	catch { destroy $w.new } ; toplevel $w.new 
	wm title $w.new "BYTA $str_"
	wm geometry $w.new +50+50
#
	update idletasks
	#grab -global $w.new
	label $w.new.label -text $str_
	
	label  $w.new.spl -text "SETPOINT  "
	label  $w.new.hll -text "HIGH ALARM"
	label  $w.new.lll -text "LOW  ALARM"

	puts $eng4_pipe_multi ra$blk_sp ;  catch { gets $eng4_pipe_multi }
	puts $eng4_pipe_multi hl$blk_hl ;  catch { gets $eng4_pipe_multi }
	puts $eng4_pipe_multi ll$blk_ll ;  catch { gets $eng4_pipe_multi }

	puts $eng4_pipe_multi ra$blk_sp ; entry  $w.new.spe ; catch {$w.new.spe insert end [format "%g" [ gets $eng4_pipe_multi ]]}
	puts $eng4_pipe_multi hl$blk_hl ; entry  $w.new.hle ; catch {$w.new.hle insert end [format "%g" [ gets $eng4_pipe_multi ]]}
	puts $eng4_pipe_multi ll$blk_ll ; entry  $w.new.lle ; catch {$w.new.lle insert end [format "%g" [ gets $eng4_pipe_multi ]]}

	button $w.new.spb   -text [format "change SETPOINT  "]
	button $w.new.hlb   -text [format "change HIGH ALARM"]
	button $w.new.llb   -text [format "change LOW  ALARM"]

	$w.new.spb configure  -command { BashNet $NODE /home/abacus/eng2 b$blk_sp_,con,ra[$w.new.spe get];destroy $w.new }
	$w.new.hlb configure  -command { BashNet $NODE /home/abacus/eng2 \'b$blk_hl_,con,hl[$w.new.hle get]\';destroy $w.new }
	$w.new.llb configure  -command { BashNet $NODE /home/abacus/eng2 \'b$blk_ll_,con,ll[$w.new.lle get]\';destroy $w.new }

	label  $w.new.aml -text "AUTO/HAND"
	set isauto [s2 $blk_acb_ ] ; get_values ;	set isauto [s2 $blk_acb_ ]
	label  $w.new.isauto -text "$isauto"
	puts $eng4_pipe_multi mm$blk_acb_ ; set mm [ gets $eng4_pipe_multi ]
	puts $eng4_pipe_multi ma$blk_acb_ ; set ma [ gets $eng4_pipe_multi ]

	button $w.new.ama -text "change to $ma" -command { BashNet $NODE /home/abacus/eng2 b$blk_ar_,con,ama ;destroy $w.new }
	button $w.new.amm -text "change to $mm" -command { BashNet $NODE /home/abacus/eng2 b$blk_ar_,con,amm ;destroy $w.new }
	button $w.new.amd -text "CLOSE" -command { destroy $w.new }
		
	grid $w.new.label  -row 0 -column 0 -rowspan 1 -columnspan 3 -sticky news
	if { $blk_sp_ } {
	   grid $w.new.spl -row 1 -column 0 -rowspan 1 -columnspan 1 -sticky news
	   grid $w.new.spe -row 1 -column 1 -rowspan 1 -columnspan 1 -sticky news
	   grid $w.new.spb -row 1 -column 2 -rowspan 1 -columnspan 1 -sticky news
	   }

	if { $blk_hl_ } {
	   grid $w.new.hll -row 2 -column 0 -rowspan 1 -columnspan 1 -sticky news
	   grid $w.new.hle -row 2 -column 1 -rowspan 1 -columnspan 1 -sticky news
	   grid $w.new.hlb -row 2 -column 2 -rowspan 1 -columnspan 1 -sticky news
	   }

	if { $blk_ll_ } {
	   grid $w.new.lll -row 3 -column 0 -rowspan 1 -columnspan 1 -sticky news
	   grid $w.new.lle -row 3 -column 1 -rowspan 1 -columnspan 1 -sticky news
	   grid $w.new.llb -row 3 -column 2 -rowspan 1 -columnspan 1 -sticky news
	   }

	if { $blk_ar_ } {
	   grid $w.new.aml -row 4 -column 0 -rowspan 1 -columnspan 1 -sticky news
	   grid $w.new.isauto -row 4 -column 1 -rowspan 1 -columnspan 1 -sticky news
	   if { [string trim $isauto] != [string trim $ma] } {
	       grid $w.new.ama -row 4 -column 2 -rowspan 1 -columnspan 1 -sticky news
	     } else {
	       grid $w.new.amm -row 4 -column 2 -rowspan 1 -columnspan 1 -sticky news
	     }
	   }
	grid $w.new.amd -row 5 -column 2 -rowspan 1 -columnspan 1 -sticky news
	
	catch { close  $eng4_pipe_multi }

	}


################# Alarm blob proc ######################


proc blob3 { block name x1 y1 colour } {
	global NODE
	global w r2$name $name
	global blob_data ra_data ra_block vn_data vn_block
	
	
	set alarm 0
	if { [info exists vn_block($block)] } then {
	  set alarm $vn_data($block)
	  } else {
	  set vn_block($block) 1
	  set vn_data($block) 1
	  }
	set $name $alarm

	if { [info exists r2$name] == 0} then {
	    catch { set r2$name [$w.p create oval $x1 $y1 \
		  [expr $x1 + 10] [expr $y1 + 10] \
		  -fill #E0E4E0 -width 1  ]}
	  }
	set blob_name [eval set r2$name]

	
	if { $alarm } { catch { $w.p itemconfigure $blob_name \
		-fill $colour -width 1  } 
	} else { catch { $w.p itemconfigure $blob_name \
		-fill #E0E4E0 -width 1  } 	}

	update idletasks
}
proc sp { block } {
	global NODE
	global sp_data sp_block
	
	set result ?
	if { [info exists sp_block($block)] } then {
	  set result $sp_data($block)
	  }
	set sp_block($block) 1
	return $result

}
proc s1 { block } {
	global NODE
	global s1_data s1_block
	
	set result ?
	if { [info exists s1_block($block)] } then {
	  set result $s1_data($block)
	  }
	set s1_block($block) 1
	return $result

}
proc s2 { block } {
	global NODE
	global s2_data s2_block
	
	set result ?
	if { [info exists s2_block($block)] } then {
	  set result $s2_data($block)
	  }
	set s2_block($block) 1
	return $result

}
proc si { block } {
	global NODE
	global si_data si_block
	
	set result "data kommer"
	if { [info exists si_block($block)] } then {
	  set result $si_data($block)
	  }
	set si_block($block) 1
	return $result

}
proc un { block } {
	global NODE
	global un_data un_block
	
	set result ?
	if { [info exists un_block($block)] } then {
	  set result $un_data($block)
	  }
	set un_block($block) 1
	return $result

}
proc ra { block } {
	global NODE
	global ra_data ra_block
	
	set result ?
	if { [info exists ra_block($block)] } then {
	  set result $ra_data($block)
	  }
	set ra_block($block) 1
	return $result

}
proc kp { block } {
	global NODE
	global kp_data kp_block
	
	set result ?
	if { [info exists kp_block($block)] } then {
	  set result $kp_data($block)
	  }
	set kp_block($block) 1
	return $result

}
proc ti { block } {
	global NODE
	global ti_data ti_block
	
	set result ?
	if { [info exists ti_block($block)] } then {
	  set result $ti_data($block)
	  }
	set ti_block($block) 1
	return $result

}
proc de { block } {
	global NODE
	global de_data de_block
	
	set result "data kommer"
	if { [info exists de_block($block)] } then {
	  set result $de_data($block)
	  }
	set de_block($block) 1
	return $result

}
## proc de { block } {
## 	global NODE
## 	global de_data de_block
## 	
## 	set result "???"
## 	if { [info exists de_block($block)] } then {
## 	  set result $de_data($block)
## 	  }
## 	set de_block($block) 1
## 	return $result
## 
## }
proc ac { block } {
	global NODE
	global ac_data ac_block
	
	set result 0
	if { [info exists ac_block($block)] } then {
	  set result $ac_data($block)
	  }
	set ac_block($block) 1
	return $result

}
proc ll { block } {
	global NODE
	global ll_data ll_block
	
	set result 0
	if { [info exists ll_block($block)] } then {
	  set result $ll_data($block)
	  }
	set ll_block($block) 1
	return $result

}
proc hl { block } {
	global NODE
	global hl_data hl_block
	
	set result 0
	if { [info exists hl_block($block)] } then {
	  set result $hl_data($block)
	  }
	set hl_block($block) 1
	return $result

}
proc am { block } {
	global NODE
	global am_data am_block
	
	set result 0
	if { [info exists am_block($block)] } then {
	  set result $am_data($block)
	  }
	set am_block($block) 1
	return $result

}
proc vn { block } {
	global NODE
	global vn_data vn_block
	
	set result 0
	if { [info exists vn_block($block)] } then {
	  set result $vn_data($block)
	  }
	set vn_block($block) 1
	return $result

}
proc bar_by_block { name block x1 y1 x2 height scale colour } {
	global NODE
	global	w fulltime halftime blinkon
	global	$name 
	
	set valx [expr [ra $block] * $height / $scale ]
	if { [expr $valx > ( $height + 5 )] || [expr $valx <  -5 ] } then {
		if { $blinkon } then {
		 set colour red 
		 set valx $height
		 } else { 
		 set colour yellow 
		 set valx $height
		 } 
		}
	if { $valx > $height } then { set valx $height }
	if { $valx < 0 } then { set valx 0 }

	if {  [info exists $name ] } then {
 		$w.p coords $name $x1 $y1 $x2 [expr {$y1 - $valx} ] 
 		} else {
		set $name [$w.p create rectangle \
		 $x1 $y1 $x2 [expr {$y1 - $valx} ] \
		 -fill $colour  -outline $colour -tags $name]	
 		
 		}
		
	$w.p raise $name
	
}
proc bar_by_value { name value x1 y1 x2 height scale colour } {
	global NODE
	global	w fulltime halftime blinkon
	global	bar
	
	set valx [expr $value * $height / $scale ]
	if { [expr $valx > ( $height + 2 )] || [expr $valx <  -5 ] } then {
		if { $blinkon } then {
		 set colour red 
		 set valx $height
		 } else { 
		 set colour yellow 
		 set valx $height
		 } 
		}
	if { $valx > $height } then { set valx $height }
	if { $valx < 0 } then { set valx 0 }
	
	if {  [info exists bar($name) ] } then {
 		$w.p coords bar($name) $x1 $y1 $x2 [expr {$y1 - $valx} ] 
 		} else {
		set bar($name) [$w.p create rectangle \
		 $x1 $y1 $x2 [expr {$y1 - $valx} ] \
		 -fill $colour  -outline $colour -tags bar($name)]	
 		
 		}
}

proc text_item_org { name x y format_ value_ } {
	global NODE
  global w lfont bg fg  ti$name
  
 catch { 
  if { [winfo exists $w.p.ti$name] == 0 } {
    catch { button  $w.p.ti$name -font $lfont -background $bg -foreground $fg \
    -activebackground $bg -activeforeground $fg \
     -pady 0 -padx 0 -relief raised -borderwidth 0 -highlightthickness 0 \
      }
    place $w.p.ti$name -x $x -y $y -anchor sw
    }
  
  $w.p.ti$name configure -text [format $format_ $value_]
  }
 }
  
proc clear_out {} {
  global w 
	global blob_data ra_data ra_block vn_data vn_block am_data am_block
	global ra3_pipe vn3_pipe sp3_pipe  sp_data sp_block
	global s13_pipe s23_pipe un3_pipe  si3_pipe
	global s1_block s2_block un_block  si_block
	global s1_data s2_data un_data  si_data
	global kp_data kp_block ti_data ti_block 

	foreach i [array names am_block] { unset am_data($i) ; unset am_block($i) }
	foreach i [array names vn_block] { unset vn_data($i) ; unset vn_block($i) }
	foreach i [array names ra_block] { unset ra_data($i) ; unset ra_block($i) }
	foreach i [array names sp_block] { unset sp_data($i) ; unset sp_block($i) }
	foreach i [array names s1_block] { unset s1_data($i) ; unset s1_block($i) }
	foreach i [array names s2_block] { unset s2_data($i) ; unset s2_block($i) }
	foreach i [array names si_block] { unset si_data($i) ; unset si_block($i) }
	foreach i [array names un_block] { unset un_data($i) ; unset un_block($i) }

	foreach i [array names kp_block] { unset kp_data($i) ; unset kp_block($i) }
	foreach i [array names ti_block] { unset ti_data($i) ; unset ti_block($i) }

  }

set bg yellow

proc text_item { name x y format_ value_ } {
	global NODE 
  global w lfont bg fg  ti$name
  
#  puts stdout "text_item  name=$name x=$x y=$y format_=$format_ value_=$value_ "
  
 catch { 
    catch { button  $w.p.ti$name -font $lfont -background $bg -foreground $fg \
    -activebackground $bg -activeforeground $fg \
     -pady 0 -padx 0 -relief raised -borderwidth 0 -highlightthickness 0 \
      }
    place $w.p.ti$name -x $x -y $y -anchor sw
    }
  
  $w.p.ti$name configure -text [format $format_ $value_]
 }
  
proc state_text_2 { name  x  y value_ text_0 fg_0 bg_0 text_1 fg_1 bg_1 } {
	global NODE
  global	w lfont bg fg  ti$name 
  
  if { [winfo exists $w.p.ti$name] == 0 } {
    
    catch { button  $w.p.ti$name -font $lfont \
     -activebackground $bg -activeforeground $fg \
     -pady 0 -padx 3 -relief flat -borderwidth 0 \
      }
    place $w.p.ti$name -x $x -y $y
    }
  
  if { $value_ } {
    $w.p.ti$name configure -background $bg_1 -foreground  $fg_1 \
    	-activebackground $bg_1 -activeforeground $fg_1
    $w.p.ti$name configure -text $text_1
    } else {
    $w.p.ti$name configure -background $bg_0 -foreground  $fg_0\
    	-activebackground $bg_0 -activeforeground $fg_0
    $w.p.ti$name configure -text $text_0
    }
  }

proc state_text_3 { name  x  y value_0 value_1 value_2 \
 text_0 fg_0 bg_0 text_1 fg_1 bg_1  text_2 fg_2 bg_2 text_3 fg_3 bg_3 \
 text_4 fg_4 bg_4 text_5 fg_5 bg_5  text_6 fg_6 bg_6 text_7 fg_7 bg_7 \
 } {
	global NODE
  global	w lfont bg fg  ti$name 
  
  if { [winfo exists $w.p.ti$name] == 0 } {
    
    catch { button  $w.p.ti$name -font $lfont \
     -activebackground $bg -activeforeground $fg \
     -pady 0 -padx 3 -relief flat -borderwidth 0 \
      }
    place $w.p.ti$name -x $x -y $y -anchor sw
    }
  
  if { !$value_0 && !$value_1 && !$value_2 } {
    $w.p.ti$name configure -background $bg_0 -foreground  $fg_0 \
    	-activebackground $bg_0 -activeforeground $fg_0
    $w.p.ti$name configure -text $text_0
    } elseif {  $value_0 && !$value_1 && !$value_2 } {
    $w.p.ti$name configure -background $bg_1 -foreground  $fg_1 \
    	-activebackground $bg_1 -activeforeground $fg_1
    $w.p.ti$name configure -text $text_1
    } elseif { !$value_0 &&  $value_1 && !$value_2 } {
    $w.p.ti$name configure -background $bg_2 -foreground  $fg_2 \
    	-activebackground $bg_2 -activeforeground $fg_2
    $w.p.ti$name configure -text $text_2
    } elseif {  $value_0 &&  $value_1 && !$value_2 } {
    $w.p.ti$name configure -background $bg_3 -foreground  $fg_3 \
    	-activebackground $bg_3 -activeforeground $fg_3
    $w.p.ti$name configure -text $text_3
    } 
     if { !$value_0 && !$value_1 &&  $value_2 } {
    $w.p.ti$name configure -background $bg_4 -foreground  $fg_4 \
    	-activebackground $bg_4 -activeforeground $fg_4
    $w.p.ti$name configure -text $text_4
    } elseif {  $value_0 && !$value_1 &&  $value_2 } {
    $w.p.ti$name configure -background $bg_5 -foreground  $fg_5 \
    	-activebackground $bg_5 -activeforeground $fg_5
    $w.p.ti$name configure -text $text_5
    } elseif { !$value_0 &&  $value_1 &&  $value_2 } {
    $w.p.ti$name configure -background $bg_6 -foreground  $fg_6 \
    	-activebackground $bg_6 -activeforeground $fg_6
    $w.p.ti$name configure -text $text_6
    } elseif {  $value_0 &&  $value_1 &&  $value_2 } {
    $w.p.ti$name configure -background $bg_7 -foreground  $fg_7 \
    	-activebackground $bg_7 -activeforeground $fg_7
    $w.p.ti$name configure -text $text_7
    } 
   
  }

proc state_text_3_r { name  x  y value_0 \
 text_0 fg_0 bg_0 text_1 fg_1 bg_1  text_2 fg_2 bg_2 text_3 fg_3 bg_3 \
 text_4 fg_4 bg_4 text_5 fg_5 bg_5  text_6 fg_6 bg_6 text_7 fg_7 bg_7 \
 } {
	global NODE
  global	w lfont bg fg  ti$name 
  
  if { [winfo exists $w.p.ti$name] == 0 } {
    
    catch { button  $w.p.ti$name -font $lfont \
     -activebackground $bg -activeforeground $fg \
     -pady 0 -padx 3 -relief flat -borderwidth 0 \
      }
    place $w.p.ti$name -x $x -y $y -anchor sw
    }
  
  switch -glob -- $value_0  {
    0* { $w.p.ti$name configure -text "$text_0" -fg $fg_0 -bg $bg_0  -activeforeground $fg_0 -activebackground $bg_0}\
    1* { $w.p.ti$name configure -text "$text_1" -fg $fg_1 -bg $bg_1  -activeforeground $fg_1 -activebackground $bg_1}\
    2* { $w.p.ti$name configure -text "$text_2" -fg $fg_2 -bg $bg_2  -activeforeground $fg_2 -activebackground $bg_2}\
    3* { $w.p.ti$name configure -text "$text_3" -fg $fg_3 -bg $bg_3  -activeforeground $fg_3 -activebackground $bg_3}\
    4* { $w.p.ti$name configure -text "$text_4" -fg $fg_4 -bg $bg_4  -activeforeground $fg_4 -activebackground $bg_4}\
    5* { $w.p.ti$name configure -text "$text_5" -fg $fg_5 -bg $bg_5  -activeforeground $fg_5 -activebackground $bg_5}\
    6* { $w.p.ti$name configure -text "$text_6" -fg $fg_6 -bg $bg_6  -activeforeground $fg_6 -activebackground $bg_6}\
    7* { $w.p.ti$name configure -text "$text_7" -fg $fg_7 -bg $bg_7  -activeforeground $fg_7 -activebackground $bg_7}\
    default { $w.p.ti$name configure -text "??????" } }
  
   
  }

proc shape_2 { name x y value_0 shape_0 shape_1 } {
  global NODE
  global	w lfont bg fg  ti$name 
  
  if { [winfo exists $w.p.ti$name] == 0 } {
    
    catch { button  $w.p.ti$name -font $lfont \
     -background $bg -foreground $fg \
     -activebackground $fg -activeforeground $bg \
     -pady 0 -padx 0 -relief raised -borderwidth 0 -highlightthickness 0 
      }
##     set cmd ""
##     set cmd "$w.p.ti$name configure -command \{ entry_error \{ti$name\} \} \;"
##     catch { puts stdout "shape_2: $cmd" }
##     puts stdout "[catch { $cmd }]"
    place $w.p.ti$name -x $x -y $y -anchor sw
    }
  if { !$value_0  } {
      $w.p.ti$name configure -image $shape_0
    } else { 
      $w.p.ti$name configure -image $shape_1
    }
}

proc shape_2_flash { name x y value_0 shape_0 shape_1 } {
  global NODE
  global blinkon
  global w lfont bg fg  ti$name
  
  if { [winfo exists $w.p.ti$name] == 0 } {
    
    catch { button  $w.p.ti$name -font $lfont \
     -background $bg -foreground $fg \
     -activebackground $fg -activeforeground $bg \
     -pady 0 -padx 0 -relief raised -borderwidth 0 -highlightthickness 0 \
      }
    place $w.p.ti$name -x $x -y $y -anchor sw
    }

  if         { !$value_0 && !$blinkon } {
      $w.p.ti$name configure -image $shape_0 
    } elseif {  $value_0 && !$blinkon  } { 
      $w.p.ti$name configure -image $shape_1
    } elseif { !$value_0 &&  $blinkon  } { 
      $w.p.ti$name configure -image $shape_1
    } elseif {  $value_0 &&  $blinkon  } { 
      $w.p.ti$name configure -image $shape_0
    }
}

proc shape_4 { name x y value_0 value_1 shape_0 shape_1 shape_2 shape_3 } {
	global NODE
  global	w lfont bg fg  ti$name 
  
  if { [winfo exists $w.p.ti$name] == 0 } {
    
    catch { button  $w.p.ti$name -font $lfont \
     -activebackground $bg -activeforeground $fg \
     -pady 0 -padx 0 -relief raised -borderwidth 0 -highlightthickness 0 \
      }
    place $w.p.ti$name -x $x -y $y -anchor sw
    }

  if         { !$value_0 && !$value_1 } {
    $w.p.ti$name configure -image $shape_0
    } elseif {  $value_0 && !$value_1 } {
    $w.p.ti$name configure -image $shape_1
    } elseif { !$value_0 &&  $value_1 } {
    $w.p.ti$name configure -image $shape_2
    } elseif {  $value_0 &&  $value_1 } {
    $w.p.ti$name configure -image $shape_3
    }
}

proc state_shape_3 { name  x  y value_0 value_1 value_2 \
 shape_0 shape_1 shape_2 shape_3 \
 shape_4 shape_5 shape_6 shape_7 \
 } {
	global NODE
  global	w lfont bg fg  ti$name 
  
  if { [winfo exists $w.p.ti$name] == 0 } {
    
    catch { button  $w.p.ti$name -font $lfont \
     -activebackground $bg -activeforeground $fg \
     -pady 0 -padx 0 -relief raised -borderwidth 0 -highlightthickness 0 \
      }
    place $w.p.ti$name -x $x -y $y -anchor sw
    }
  
  if { !$value_0 && !$value_1 && !$value_2 } {
    $w.p.ti$name configure -image $shape_0
    } elseif {  $value_0 && !$value_1 && !$value_2 } {
    $w.p.ti$name configure -image $shape_1
    } elseif { !$value_0 &&  $value_1 && !$value_2 } {
    $w.p.ti$name configure -image $shape_2
    } elseif {  $value_0 &&  $value_1 && !$value_2 } {
    $w.p.ti$name configure -image $shape_3
    } elseif { !$value_0 && !$value_1 &&  $value_2 } {
    $w.p.ti$name configure -image $shape_4
    } elseif {  $value_0 && !$value_1 &&  $value_2 } {
    $w.p.ti$name configure -image $shape_5
    } elseif { !$value_0 &&  $value_1 &&  $value_2 } {
    $w.p.ti$name configure -image $shape_6
    } elseif {  $value_0 &&  $value_1 &&  $value_2 } {
    $w.p.ti$name configure -image $shape_7
    } 
   
  }

proc state_shape_3_r { name  x  y value_0 \
 shape_0 shape_1 shape_2 shape_3 \
 shape_4 shape_5 shape_6 shape_7 \
 } {
	global NODE
  global	w lfont bg fg  ti$name 
  
  if { [winfo exists $w.p.ti$name] == 0 } {
    
    catch { button  $w.p.ti$name -font $lfont \
     -activebackground $bg -activeforeground $fg \
     -pady 0 -padx 0 -relief raised -borderwidth 0 -highlightthickness 0 \
      }
    place $w.p.ti$name -x $x -y $y -anchor sw
     }
  
  $w.p.ti$name configure -image question

  switch -glob -- $value_0  {
    0* { $w.p.ti$name configure -image $shape_0 }\
    1* { $w.p.ti$name configure -image $shape_1 }\
    2* { $w.p.ti$name configure -image $shape_2 }\
    3* { $w.p.ti$name configure -image $shape_3 }\
    4* { $w.p.ti$name configure -image $shape_4 }\
    5* { $w.p.ti$name configure -image $shape_5 }\
    6* { $w.p.ti$name configure -image $shape_6 }\
    7* { $w.p.ti$name configure -image $shape_7 }\
    default { $w.p.ti$name configure -image question } }
  
  }

proc shape_update { name shape x y } {
	global NODE
	global w fulltime halftime blinkon
	global	pump_data blob_data ra_data ra_block vn_data vn_block
	global kp_data kp_block ti_data ti_block 


	#catch { destroy $w.p.$name }
	if [info exists pump_data($name)] {
		if { $vn_data($trip) } then \
			{
			  if { $blinkon  } then {$w.p.$name configure -image pumpred  -borderwidth 0
			  } else {$w.p.$name configure -image pumporg  -borderwidth 0}
			} else {
				if { $vn_data($running) } then \
					{ $w.p.$name configure -image pumpgreen  -borderwidth 0 
				} else	{ $w.p.$name configure -image pumpyellow  -borderwidth 0}
			}
	
		} else {
		label $w.p.$name -image pumporg -borderwidth 0
		place $w.p.$name -x $x -y $y
		set pump_data($name) init
		set vn_block($trip) 1
		set vn_block($running) 1
		set vn_data($trip) 0
		set vn_data($running) 0
		}
	
	update idletasks
}

proc pump_update { pump trip running x y } {
	global NODE
	global w fulltime halftime blinkon
	global	pump_data blob_data ra_data ra_block vn_data vn_block
	global kp_data kp_block ti_data ti_block 


	#catch { destroy $w.p.$pump }
	if [info exists pump_data($pump)] {
		if { $vn_data($trip) } then \
			{
			  if { $blinkon  } then {$w.p.$pump configure -image pumpred  -borderwidth 0
			  } else {$w.p.$pump configure -image pumporg  -borderwidth 0}
			} else {
				if { $vn_data($running) } then \
					{ $w.p.$pump configure -image pumpgreen  -borderwidth 0 
				} else	{ $w.p.$pump configure -image pumpyellow  -borderwidth 0}
			}
	
		} else {
		label $w.p.$pump -image pumporg -borderwidth 0
		place $w.p.$pump -x $x -y $y
		set pump_data($pump) init
		set vn_block($trip) 1
		set vn_block($running) 1
		set vn_data($trip) 0
		set vn_data($running) 0
		}
	
	update idletasks
}

proc omr_update { omr trip running x y } {
	global NODE
	global w fulltime halftime blinkon
	global	omr_data blob_data ra_data ra_block vn_data vn_block

	#catch { destroy $w.p.$omr }
	if [info exists omr_data($omr)] {
		if { $vn_data($trip) } then \
			{
			  $w.p.$omr configure -image omrred  -borderwidth 0
			  
			} else {
				if { $vn_data($running) } then \
					{ $w.p.$omr configure -image omrgreen  -borderwidth 0 
				} else	{ $w.p.$omr configure -image omryellow  -borderwidth 0}
			}
	
		} else {
		label $w.p.$omr -image omrorg -borderwidth 0
		place $w.p.$omr -x $x -y $y
		set omr_data($omr) init
		set vn_block($trip) 1
		set vn_block($running) 1
		set vn_data($trip) 0
		set vn_data($running) 0
		}
	
	update idletasks
}
set OLD_NODE "MaryHadALittleLamb"
set purge_1_0 1
proc get_values_org { } {
	global NODE
	global blob_data ra_data ra_block
	global ac_data ac_block
	global hl_data hl_block
	global ll_data ll_block
	global vn_data vn_block
	global ra3_pipe eng4_pipe sp3_pipe  sp_data sp_block
	global s13_pipe s23_pipe un3_pipe  si3_pipe
	global s1_block s2_block un_block  si_block
	global s1_data s2_data un_data  si_data
	global OLD_NODE
	global kp_data kp_block ti_data ti_block 
	
	if { $NODE != $OLD_NODE } {
	  if { [info exists eng4_pipe] } then {
	      catch { close $eng4_pipe }
	      unset eng4_pipe
	    }
	  }
	set OLD_NODE $NODE
	
## 	if { [info exists eng4_pipe] } then {
## 	  
## 	  } else {
## 	  set eng4_pipe [open  "| hose $NODE 9000 -slave " {RDWR } ]
## 	  fconfigure $eng4_pipe -buffering line
## 	  puts $eng4_pipe /home/abacus/eng4
## 	  }

	if { [info exists eng4_pipe] } then {
	  
	  } else {
	  set eng4_pipe [socket $NODE 9000]
	  fconfigure $eng4_pipe -buffering line
	  puts $eng4_pipe "/home/abacus/eng4 "
	  }
	
	
	foreach i [array names ll_block] {
	  if { $ll_block($i) <= 2 } then {
		puts $eng4_pipe ac$i
		set ll_data($i) [ gets $eng4_pipe ]
		incr ll_block($i) 1
		} else { unset ll_block($i) ; unset ll_data($i) }
	  }

	foreach i [array names hl_block] {
	  if { $hl_block($i) <= 2 } then {
		puts $eng4_pipe ac$i
		set hl_data($i) [ gets $eng4_pipe ]
		incr hl_block($i) 1
		} else { unset hl_block($i) ; unset hl_data($i) }
	  }

	foreach i [array names ac_block] {
	  if { $ac_block($i) <= 2 } then {
		puts $eng4_pipe ac$i
		set ac_data($i) [ gets $eng4_pipe ]
		incr ac_block($i) 1
		} else { unset ac_block($i) ; unset ac_data($i) }
	  }

	foreach i [array names vn_block] {
	  if { $vn_block($i) <= 2 } then {
		puts $eng4_pipe vn$i
		set vn_data($i) [ gets $eng4_pipe ]
		incr vn_block($i) 1
		} else { unset vn_block($i) ; unset vn_data($i) }
	  }

	foreach i [array names ra_block] {
	  if { $ra_block($i) <= 2 } then {
		puts $eng4_pipe ra$i
		set ra_data($i) [ gets $eng4_pipe ]
		incr ra_block($i) 1
		} else { unset ra_block($i) ; unset ra_data($i)  }
	  }

	foreach i [array names kp_block] {
	  if { $kp_block($i) <= 2 } then {
		puts $eng4_pipe ra$i
		set kp_data($i) [ gets $eng4_pipe ]
		incr kp_block($i) 1
		} else { unset kp_block($i) ; unset kp_data($i)  }
	  }

	foreach i [array names ti_block] {
	  if { $ti_block($i) <= 2 } then {
		puts $eng4_pipe ra$i
		set ti_data($i) [ gets $eng4_pipe ]
		incr ti_block($i) 1
		} else { unset ti_block($i) ; unset ti_data($i)  }
	  }
#; puts stdout "unset ra_($i)"

	foreach i [array names sp_block] {
	  if { $sp_block($i) <= 2 } then {
		puts $eng4_pipe sp$i
		set sp_data($i) [ gets $eng4_pipe ]
		incr sp_block($i) 1
		} else { unset sp_block($i) ; unset sp_data($i) }
	  }

	foreach i [array names s1_block] {
	  if { $s1_block($i) <= 2 } then {
		puts $eng4_pipe s1$i
		set s1_data($i) [ gets $eng4_pipe ]
		incr s1_block($i) 1
		} else { unset s1_block($i) ; unset s1_data($i) }
	  }

	foreach i [array names s2_block] {
	  if { $s2_block($i) <= 2 } then {
		puts $eng4_pipe s2$i
		set s2_data($i) [ gets $eng4_pipe ]
		incr s2_block($i) 1
		} else { unset s2_block($i) ; unset s2_data($i) }
	  }

	foreach i [array names si_block] {
	  if { $si_block($i) <= 2 } then {
		puts $eng4_pipe si$i
		set si_data($i) [ gets $eng4_pipe ]
		incr si_block($i) 1
		} else { unset si_block($i) ; unset si_data($i) }
	  }

	foreach i [array names un_block] {
	  if { $un_block($i) <= 2 } then {
		puts $eng4_pipe un$i
		set un_data($i) [ gets $eng4_pipe ]
		incr un_block($i) 1
		} else { unset un_block($i) ; unset un_data($i) }
	  }

}

proc get_values { } {
	global NODE
	global blob_data ra_data ra_block
	global de_data de_block
	global ac_data ac_block
	global hl_data hl_block
	global ll_data ll_block
	global am_data am_block
	global vn_data vn_block
	global ra3_pipe eng4_pipe eng4_pipe_de sp3_pipe  sp_data sp_block
	global s13_pipe s23_pipe un3_pipe  si3_pipe
	global s1_block s2_block un_block  si_block
	global s1_data s2_data un_data  si_data
	global OLD_NODE
	global purge_1_0
	global kp_data kp_block ti_data ti_block 
	
	if { $NODE != $OLD_NODE } {
	  if { [info exists eng4_pipe] } then {
	      catch { close $eng4_pipe }
	      unset eng4_pipe
	    }
	  }
	set OLD_NODE $NODE
	
## 	if { [info exists eng4_pipe] } then {
## 	  
## 	  } else {
## 	  set eng4_pipe [open  "| hose $NODE 9000 -slave " {RDWR } ]
## 	  fconfigure $eng4_pipe -buffering line
## 	  puts $eng4_pipe /home/abacus/eng4
## 	  }

	if { [info exists eng4_pipe] } then {
	  
	  } else {
	  set eng4_pipe [socket $NODE 9000]
	#########  fconfigure $eng4_pipe -buffering line
	  puts $eng4_pipe "/home/abacus/eng4 "
	 ## puts stdout "Opening \$eng4_pipe $eng4_pipe "
	  }
	
	if { [info exists eng4_pipe_de] } then {
	  
	  } else {
	  set eng4_pipe_de [socket $NODE 9000]
	#########  fconfigure $eng4_pipe_de -buffering line
	  puts $eng4_pipe_de "/home/abacus/eng4 "
	  }
	
	
	foreach i [array names de_block] {
	  if { $de_block($i) <= 2 } then {
		puts $eng4_pipe_de de$i } }
	flush $eng4_pipe_de
	foreach i [array names de_block] {
	  if { $de_block($i) <= 2 } then {
		update idletasks
		set de_data($i) [ gets $eng4_pipe_de ]
		incr de_block($i) $purge_1_0
		} else { unset de_block($i) ; unset de_data($i) }
	  }

## 	foreach i [array names de_block] {
## 	  if { $de_block($i) <= 2 } then {
## 		puts $eng4_pipe de$i } }
## 	flush $eng4_pipe
## 	foreach i [array names de_block] {
## 	  if { $de_block($i) <= 2 } then {
## 		update idletasks
## 		set de_data($i) [ gets $eng4_pipe ]
## 		incr de_block($i) $purge_1_0
## 		} else { unset de_block($i) ; unset de_data($i) }
## 	  }

	
	foreach i [array names kp_block] {
	  if { $kp_block($i) <= 2 } then {
		puts $eng4_pipe kp$i } }
	flush $eng4_pipe
	foreach i [array names kp_block] {
	  if { $kp_block($i) <= 2 } then {
		update idletasks
		set kp_data($i) [ gets $eng4_pipe ]
		incr kp_block($i) $purge_1_0
		} else { unset kp_block($i) ; unset kp_data($i) }
	  }

	foreach i [array names ti_block] {
	  if { $ti_block($i) <= 2 } then {
		puts $eng4_pipe ti$i } }
	flush $eng4_pipe
	foreach i [array names ti_block] {
	  if { $ti_block($i) <= 2 } then {
		update idletasks
		set ti_data($i) [ gets $eng4_pipe ]
		incr ti_block($i) $purge_1_0
		} else { unset ti_block($i) ; unset ti_data($i) }
	  }

	foreach i [array names ll_block] {
	  if { $ll_block($i) <= 2 } then {
		puts $eng4_pipe ll$i } }
	flush $eng4_pipe
	foreach i [array names ll_block] {
	  if { $ll_block($i) <= 2 } then {
		update idletasks
		set ll_data($i) [ gets $eng4_pipe ]
		incr ll_block($i) $purge_1_0
		} else { unset ll_block($i) ; unset ll_data($i) }
	  }

	foreach i [array names hl_block] {
	  if { $hl_block($i) <= 2 } then {
		puts $eng4_pipe hl$i } }
	flush $eng4_pipe
	foreach i [array names hl_block] {
	  if { $hl_block($i) <= 2 } then {
		update idletasks
		set hl_data($i) [ gets $eng4_pipe ]
		incr hl_block($i) $purge_1_0
		} else { unset hl_block($i) ; unset hl_data($i) }
	  }

	foreach i [array names ac_block] {
	  if { $ac_block($i) <= 2 } then {
		puts $eng4_pipe ac$i } }
	flush $eng4_pipe
	foreach i [array names ac_block] {
	  if { $ac_block($i) <= 2 } then {
		update idletasks
		set ac_data($i) [ gets $eng4_pipe ]
		incr ac_block($i) $purge_1_0
		} else { unset ac_block($i) ; unset ac_data($i) }
	  }

	foreach i [array names am_block] {
	  if { $am_block($i) <= 2 } then {
		puts $eng4_pipe am$i } }
	flush $eng4_pipe
	foreach i [array names am_block] {
	  if { $am_block($i) <= 2 } then {
		update idletasks
		set am_data($i) [ gets $eng4_pipe ]
		incr am_block($i) $purge_1_0
		} else { unset am_block($i) ; unset am_data($i) }
	  }

	foreach i [array names vn_block] {
	  if { $vn_block($i) <= 2 } then {
		puts $eng4_pipe vn$i } }
	flush $eng4_pipe
	foreach i [array names vn_block] {
	  if { $vn_block($i) <= 2 } then {
		update idletasks
		set vn_data($i) [ gets $eng4_pipe ]
		incr vn_block($i) $purge_1_0
		} else { unset vn_block($i) ; unset vn_data($i) }
	  }

	foreach i [array names ra_block] {
	  if { $ra_block($i) <= 2 } then {
		puts $eng4_pipe ra$i } }
	flush $eng4_pipe
	foreach i [array names ra_block] {
	  if { $ra_block($i) <= 2 } then {
		update idletasks
		set ra_data($i) [ gets $eng4_pipe ]
		incr ra_block($i) $purge_1_0
		} else { unset ra_block($i) ; unset ra_data($i)  }
	  }
#; puts stdout "unset ra_($i)"

	foreach i [array names sp_block] {
	  if { $sp_block($i) <= 2 } then {
		puts $eng4_pipe sp$i } }
	flush $eng4_pipe
	foreach i [array names sp_block] {
	  if { $sp_block($i) <= 2 } then {
		update idletasks
		set sp_data($i) [ gets $eng4_pipe ]
		incr sp_block($i) $purge_1_0
		} else { unset sp_block($i) ; unset sp_data($i) }
	  }

	foreach i [array names s1_block] {
	  if { $s1_block($i) <= 2 } then {
		puts $eng4_pipe s1$i } }
	flush $eng4_pipe
	foreach i [array names s1_block] {
	  if { $s1_block($i) <= 2 } then {
		update idletasks
		set s1_data($i) [ gets $eng4_pipe ]
		incr s1_block($i) $purge_1_0
		} else { unset s1_block($i) ; unset s1_data($i) }
	  }

	foreach i [array names s2_block] {
	  if { $s2_block($i) <= 2 } then {
		puts $eng4_pipe s2$i } }
	flush $eng4_pipe
	foreach i [array names s2_block] {
	  if { $s2_block($i) <= 2 } then {
		update idletasks
		set s2_data($i) [ gets $eng4_pipe ]
		incr s2_block($i) $purge_1_0
		} else { unset s2_block($i) ; unset s2_data($i) }
	  }

	foreach i [array names si_block] {
	  if { $si_block($i) <= 2 } then {
		puts $eng4_pipe si$i } }
	flush $eng4_pipe
	foreach i [array names si_block] {
	  if { $si_block($i) <= 2 } then {
		update idletasks
		set si_data($i) [ gets $eng4_pipe ]
		incr si_block($i) $purge_1_0
		} else { unset si_block($i) ; unset si_data($i) }
	  }

	foreach i [array names un_block] {
	  if { $un_block($i) <= 2 } then {
		puts $eng4_pipe un$i } }
	flush $eng4_pipe
	foreach i [array names un_block] {
	  if { $un_block($i) <= 2 } then {
		update idletasks
		set un_data($i) [ gets $eng4_pipe ]
		incr un_block($i) $purge_1_0
		} else { unset un_block($i) ; unset un_data($i) }
	  }

	set purge_1_0 1
}

destroy $w.welcome
#source ./dp2.tcl
source ./mp1.tcl
