#!/bin/sh
# linuxinfo.sh - Linux information
# the next line restarts using wish \
exec wish "$0" "$@" -geometry +0+0

# Edit this by all means, but be careful of syntax!
# A '#' starts a comment
# A \ at the end of a line is a continuation, miss it out at your own risk!
# quite marks much match each other. etc. etc.
# If you do an edit, try it out frequently. Tcl/tk throughs up an error window
# if it can't understand something; you then can chose to see a stack listing, which might
# be of some help!


#-geometry +0+550

set NODE	localhost
set NODE	localhost
#set NODE small
#set NODE	inco
#set NODE small
#set NODE	inco

set bold "-background #43ce80 -relief raised -borderwidth 1"
set normal "-background {} -relief flat"

set w .page
wm title . [format "Abacus / node:$NODE Journal Listing (updating)" ]
wm resizable . 0 0


#image create photo Pic

frame $w 
frame $w.frame
frame $w.menu -relief raised -bd 2

pack $w $w.menu $w.frame
text $w.frame.mess  -wrap word  -width 80 -height 24  -setgrid true \
-yscrollcommand "$w.frame.s set"
scrollbar $w.frame.s -orient vert -command "$w.frame.mess yview"
pack $w.frame.s -side right -fill y
pack $w.frame.mess -side left -fill both -expand true

############## Menu stuff defined here ################################
#frame $w.menu -relief raised -bd 2

set prio1 1
set prio2 1

set m $w.menu.file.m
menubutton $w.menu.file -text "PRIORITIES" -menu $m -underline 0
menu $m -tearoff 0
$m add separator
$m add command -label "All priorities" -command { set prio1 1 ; set prio2 1 ; set prio3 1 ; set prio4 1 ; }
$m add command -label "Priorities 1&2" -command { set prio1 1 ; set prio2 1 ; set prio3 0 ; set prio4 0 ; }
$m add command -label "Priorities 3&4" -command { set prio1 0 ; set prio2 0 ; set prio3 1 ; set prio4 1 ; }
$m add check -label "PRIO=1" -variable prio1
$m add check -label "PRIO=2" -variable prio2
$m add check -label "PRIO=3" -variable prio3
$m add check -label "PRIO=4" -variable prio4
pack $w.menu.file -side left

set family helvetica
set family Times
set family Courier

$w.frame.mess tag configure norm    -font -*-$family-medium-R-Normal--*-120-*-*-*-*-*-*
$w.frame.mess tag configure prio1    -font -*-$family-medium-R-Normal--*-120-*-*-*-*-*-* -background red -foreground white 
$w.frame.mess tag configure prio2    -font -*-$family-medium-R-Normal--*-120-*-*-*-*-*-* -background blue -foreground white 
$w.frame.mess tag configure prio3    -font -*-$family-medium-R-Normal--*-120-*-*-*-*-*-* -background yellow -foreground black 
$w.frame.mess tag configure prio4    -font -*-$family-medium-R-Normal--*-120-*-*-*-*-*-* -background grey -foreground black 


$w.frame.mess tag configure bold    -font -*-$family-Bold-R-Normal--*-120-*-*-*-*-*-*
$w.frame.mess tag configure big     -font -*-$family-Bold-R-Normal--*-140-*-*-*-*-*-*
$w.frame.mess tag configure bigcenter	    -justify center  -underline true\
    -font -*-$family-Bold-R-Normal--*-140-*-*-*-*-*-*
$w.frame.mess tag configure verybigblue -justify center -foreground blue -underline true\
    -font -*-$family-Bold-R-Normal--*-240-*-*-*-*-*-*

##  $w.frame.mess tag configure norm	    -font {$family 12 }
##  $w.frame.mess tag configure bold	    -font {$family 12 bold}
##  $w.frame.mess tag configure big	    -font {$family 14 }
##  $w.frame.mess tag configure bigcenter   -justify center  -underline true\
##  	    -font {$family 14 }
##  $w.frame.mess tag configure verybigblue -justify center -foreground blue -underline true\
##  	    -font {$family 24 }
##
proc Intext {txt {tgs {norm}} } {
 global w
 $w.frame.mess insert end $txt $tgs
}

## set tfile [open "/home/abacus/journal.lst" r]
## $w.frame.mess insert end [read $tfile]
## $w.frame.mess yview moveto 1.0
## close $tfile

set grep_par "?"
if { $prio1 } { append grep_par "1" }
if { $prio2 } { append grep_par "2" }
if { $prio3 } { append grep_par "3" }
if { $prio4 } { append grep_par "4" }

#$w.frame.mess insert end [exec /home/abacus/bashnet $NODE tail "-n 500 /home/abacus/journal.lst" | grep $grep_par ] norm
exec /home/abacus/sim/journal_updating-sub1.sh $grep_par
source journal_updating-sub1.sh.tmp
$w.frame.mess yview moveto 1.0

set scrollpos [$w.frame.mess yview]
after 5000 updat 
proc updat {} { 
	global	w scrollpos tfile scrollp1 scrollpos2 NODE 
	global	prio1 prio2 prio3 prio4 grep_par

	if { [winfo viewable .] } {
	
		set grep_par "?"
		if { $prio1 } { append grep_par "1" }
		if { $prio2 } { append grep_par "2" }
		if { $prio3 } { append grep_par "3" }
		if { $prio4 } { append grep_par "4" }

		set scrollpos [$w.frame.mess yview]
 		$w.frame.mess delete 1.0 end
		##$w.frame.mess insert end [exec /home/abacus/bashnet $NODE tail "-n 500 /home/abacus/journal.lst" | grep $grep_par  ] prio1 ;# norm
		
		exec /home/abacus/sim/journal_updating-sub1.sh $grep_par
		source journal_updating-sub1.sh.tmp
		
		$w.frame.mess yview moveto $scrollpos2
		set scrollpos [$w.frame.mess yview]
	  }
	after 5000 updat 
	}
	
proc updat2 {} { 
	global  w scrollpos tfile scrollp1 scrollpos2 NODE 
	set scrollpos [$w.frame.mess yview]
	set scrollpos2 [lrange $scrollpos 0 0]
	
	
	set scrollp1 [expr 1 - ( 25 / [$w.frame.mess index end] ) ]
 	if {$scrollpos2 >= $scrollp1} { set scrollpos2 1.0 
		$w.frame.s configure -background darkgreen
 		wm title . [format "Abacus / node:$NODE Journal Listing " ]
		} else {
		$w.frame.s configure -background darkred
 		wm title . [format "Abacus / node:$NODE Journal Listing (bottom line not the latest !)" ]
		}
	after 500 updat2
	}

updat2

bind . <Control-c> {destroy .}
bind . <Control-C> {destroy .}
