#!/bin/sh
# linuxinfo.sh - Linux information
# the next line restarts using wish \
exec wish "$0" "$@" -geometry +0+0

# Edit this by all means, but be careful of syntax!
# A '#' starts a comment
# A \ at the end of a line is a continuation, miss it out at your own risk!
# quite marks much match each other. etc. etc.
# If you do an edit, try it out frequently. Tcl/tk throughs up an error window
# if it can't understand something; you then can chose to see a stack listing, which might
# be of some help!


#-geometry +0+550

set NODE	inco

set bold "-background #43ce80 -relief raised -borderwidth 1"
set normal "-background {} -relief flat"

set w .page
set wm_title [format "Abacus / node:$NODE Operator Codes Listing" ]
wm title . $wm_title
wm resizable . 0 0


#image create photo Pic

frame $w 
frame $w.frame
pack $w $w.frame
text $w.frame.mess  -wrap word  -width 80 -height 24  -setgrid true \
-yscrollcommand "$w.frame.s set"
scrollbar $w.frame.s -orient vert -command "$w.frame.mess yview"
pack $w.frame.s -side right -fill y
pack $w.frame.mess -side left -fill both -expand true

set family helvetica
set family Courier

$w.frame.mess tag configure norm 	-font -*-$family-medium-R-Normal--*-120-*-*-*-*-*-*
$w.frame.mess tag configure bold 	-font -*-$family-Bold-R-Normal--*-120-*-*-*-*-*-*
$w.frame.mess tag configure big 	-font -*-$family-Bold-R-Normal--*-140-*-*-*-*-*-*
$w.frame.mess tag configure bigcenter 	-justify center  -underline true\
	-font -*-$family-Bold-R-Normal--*-140-*-*-*-*-*-*
$w.frame.mess tag configure verybigblue -justify center -foreground blue -underline true\
	-font -*-$family-Bold-R-Normal--*-240-*-*-*-*-*-*

proc Intext {txt {tgs {norm}} } {
 global w
 $w.frame.mess insert end $txt $tgs
}

## set tfile [open "/home/abacus/journal.lst" r]
## $w.frame.mess insert end [read $tfile]
## $w.frame.mess yview moveto 1.0
## close $tfile
$w.frame.mess insert end "Data on its way" norm
$w.frame.mess yview moveto 1.0
#$w.frame.mess yview moveto 0.0

set scrollpos [$w.frame.mess yview]
after 5000 updat 
proc updat {} { 
	global	w scrollpos tfile scrollp1 scrollpos2 NODE
	global	wm_title
	# [format "Abacus / node:$NODE Operator Codes Listing" ]

	wm title . [format "%s Updating !!" $wm_title]
	update idletasks

	if { [winfo viewable .] } {
		set scrollpos [$w.frame.mess yview]
		set scrollpos2 [lrange $scrollpos 0 0]
 		
 		set buftext {}
 		foreach bl {
			8001 8002 8003 8004  8009
			8010 8011  8013 8014 8015 8016  8018 8019
			8020   8023   8026 8027 8028 8029
			 8031 8032 8033  8035 8036 8037 8038 
			8040 8041 8042 8043 8044 8045 8046 8047 8048 8049
			8050 8051 8052 8053  8055 8056 8057 
			8090 8091 8092  8094  8096 8097 8098 8099
			8100 8101 8102 8103 8104 
			 8111  8113 8114 8115 8116 
			8120 8121 8122  8133 8134 8135 
			8140 8141 8142 
			 8151 8152  8197 8198 
			8200 
			8210 
			8249
			8250 8251 8252 8253 8254 8255 8256 8257 8258 8259
			8260 8261 8262 8263 8264 8265 8266 8267 8268 8269
			8270 8271 8272 8273 8274 8275 8276 8277 8278 8279
			8280 8281 8282 8283 8284 8285 8286 8287 8288 8289
			8290 8291 8292 8293 8294 8295 8296 8297 8298 8299
			8300 8301 8302 8303 
			
			8320 8321 
			8340 8341 8342 8343 
			 8351 8352 8353 8354 8355 8356 8357 8358 8359
			8360  8365 8366 8367 8368 8369
			 8373 8374 8375 8376 8377 8378 8379
			8380 8381 8382 8383 8384 8385 8386 8387 8388 8389 
			8390 8391 8392 8393 8394  
			8400 } {
				catch { append buftext [format "%4d %-24.24s %7.7s %-8.8s %7.7s hl %7.7s ll %7.7s\n" \
				  $bl [si $bl] [sp $bl] [un $bl] [ra $bl]  [hl $bl] [ll $bl]]  }
				}
 		$w.frame.mess delete 1.0 end
		$w.frame.mess insert end $buftext norm

		$w.frame.mess yview moveto $scrollpos2
		set scrollpos [$w.frame.mess yview]
	  }
	get_values
	wm title . [format "%s" $wm_title]
	after 5000 updat 
	}
	
proc updat2 {} { 
	global  w scrollpos tfile scrollp1 scrollpos2 NODE 
	set scrollpos [$w.frame.mess yview]
	set scrollpos2 [lrange $scrollpos 0 0]
	catch { set scrollp1 [expr 1 - ( 25 / [lrange [$w.frame.mess tag ranges norm] 1 1] ) ] }
 	if {$scrollpos2 >= $scrollp1} { set scrollpos2 1.0 
		$w.frame.s configure -background darkgreen
 		wm title . [format "Abacus / node:$NODE  Operator Codes Listing" ]
		} else {
		$w.frame.s configure -background darkred
 		wm title . [format "Abacus / node:$NODE  Operator Codes Listing" ]
		}
	after 500 updat2
	}

updat2
proc hl { block } {
	global NODE
	global hl_data hl_block
	
	set result ?
	if { [info exists hl_block($block)] } then {
	  set result $hl_data($block)
	  }
	set hl_block($block) 1
	return $result

}
proc ll { block } {
	global NODE
	global ll_data ll_block
	
	set result ?
	if { [info exists ll_block($block)] } then {
	  set result $ll_data($block)
	  }
	set ll_block($block) 1
	return $result

}
proc sp { block } {
	global NODE
	global sp_data sp_block
	
	set result ?
	if { [info exists sp_block($block)] } then {
	  set result $sp_data($block)
	  }
	set sp_block($block) 1
	return $result

}
proc s1 { block } {
	global NODE
	global s1_data s1_block
	
	set result ?
	if { [info exists s1_block($block)] } then {
	  set result $s1_data($block)
	  }
	set s1_block($block) 1
	return $result

}
proc s2 { block } {
	global NODE
	global s2_data s2_block
	
	set result ?
	if { [info exists s2_block($block)] } then {
	  set result $s2_data($block)
	  }
	set s2_block($block) 1
	return $result

}
proc si { block } {
	global NODE
	global si_data si_block
	
	set result ?
	if { [info exists si_block($block)] } then {
	  set result $si_data($block)
	  }
	set si_block($block) 1
	return $result

}
proc un { block } {
	global NODE
	global un_data un_block
	
	set result ?
	if { [info exists un_block($block)] } then {
	  set result $un_data($block)
	  }
	set un_block($block) 1
	return $result

}
proc ra { block } {
	global NODE
	global ra_data ra_block
	
	set result ?
	if { [info exists ra_block($block)] } then {
	  set result $ra_data($block)
	  }
	set ra_block($block) 1
	return $result

}
proc ac { block } {
	global NODE
	global ac_data ac_block
	
	set result 0
	if { [info exists ac_block($block)] } then {
	  set result $ac_data($block)
	  }
	set ac_block($block) 1
	return $result

}
proc vn { block } {
	global NODE
	global vn_data vn_block
	
	set result 0
	if { [info exists vn_block($block)] } then {
	  set result $vn_data($block)
	  }
	set vn_block($block) 1
	return $result

}
proc entry_stuff_multi_acb { blk_acb } {
	global NODE
	global w blkno
	global str_ blk_acb_ blk_sp_ blk_hl_ blk_ll_ blk_ar_ blk_st_ mm ma
	
	set blk_acb_ $blk_acb
	set blk_sp_ $blk_acb
	set blk_hl_ $blk_acb
	set blk_ll_ $blk_acb
	set blk_ar_ $blk_acb
	set blk_st_ $blk_acb
	
	set eng4_pipe_multi [socket $NODE 9000]
	fconfigure $eng4_pipe_multi -buffering line
	puts $eng4_pipe_multi "/home/abacus/eng4 "

	puts $eng4_pipe_multi "si$blk_acb"
	catch { set str_ [gets $eng4_pipe_multi] }
	
	toplevel $w.new 
	wm title $w.new "CHANGE $str_"
	wm geometry $w.new +50+50
#
	update idletasks
	#grab -global $w.new
	label $w.new.label -text $str_
	
	label  $w.new.spl -text "SETPOINT  "
	label  $w.new.hll -text "HIGH ALARM"
	label  $w.new.lll -text "LOW  ALARM"

	puts $eng4_pipe_multi is$blk_acb ;  catch { set blk_sp_ [gets $eng4_pipe_multi] }
##puts stdout "blk_acb $blk_acb blk_sp_ $blk_sp_ "
	puts $eng4_pipe_multi ra$blk_sp_ ;  catch { gets $eng4_pipe_multi }
	puts $eng4_pipe_multi hl$blk_hl_ ;  catch { gets $eng4_pipe_multi }
	puts $eng4_pipe_multi ll$blk_ll_ ;  catch { gets $eng4_pipe_multi }

	puts $eng4_pipe_multi ra$blk_sp_ ; entry  $w.new.spe ; catch {$w.new.spe insert end [format "%f" [ gets $eng4_pipe_multi ]]}
	puts $eng4_pipe_multi hl$blk_hl_ ; entry  $w.new.hle ; catch {$w.new.hle insert end [format "%f" [ gets $eng4_pipe_multi ]]}
	puts $eng4_pipe_multi ll$blk_ll_ ; entry  $w.new.lle ; catch {$w.new.lle insert end [format "%f" [ gets $eng4_pipe_multi ]]}

	button $w.new.spb   -text [format "change SETPOINT  "]
	button $w.new.hlb   -text [format "change HIGH ALARM"]
	button $w.new.llb   -text [format "change LOW  ALARM"]

	$w.new.spb configure  -command { exec /home/abacus/bashnet $NODE /home/abacus/eng2 b$blk_sp_,con,ra[$w.new.spe get];destroy $w.new }
	$w.new.hlb configure  -command { exec /home/abacus/bashnet $NODE /home/abacus/eng2 \'b$blk_hl_,con,hl[$w.new.hle get]\';destroy $w.new }
	$w.new.llb configure  -command { exec /home/abacus/bashnet $NODE /home/abacus/eng2 \'b$blk_ll_,con,ll[$w.new.lle get]\';destroy $w.new }

	label  $w.new.aml -text "AUTO/HAND"
	set isauto [s2 $blk_acb_ ]
	label  $w.new.isauto -text "$isauto"
	puts $eng4_pipe_multi mm$blk_acb_ ; set mm [ gets $eng4_pipe_multi ]
	puts $eng4_pipe_multi ma$blk_acb_ ; set ma [ gets $eng4_pipe_multi ]

	button $w.new.ama -text "change to $ma" -command { exec /home/abacus/bashnet $NODE /home/abacus/eng2 b$blk_ar_,con,ama ;destroy $w.new }
	button $w.new.amm -text "change to $mm" -command { exec /home/abacus/bashnet $NODE /home/abacus/eng2 b$blk_ar_,con,amm ;destroy $w.new }
	button $w.new.amd -text "CANCEL" -command { destroy $w.new }
		
	grid $w.new.label  -row 0 -column 0 -rowspan 1 -columnspan 3 -sticky news
	if { $blk_sp_ } {
	   grid $w.new.spl -row 1 -column 0 -rowspan 1 -columnspan 1 -sticky news
	   grid $w.new.spe -row 1 -column 1 -rowspan 1 -columnspan 1 -sticky news
	   grid $w.new.spb -row 1 -column 2 -rowspan 1 -columnspan 1 -sticky news
	   }

	if { $blk_hl_ } {
	   grid $w.new.hll -row 2 -column 0 -rowspan 1 -columnspan 1 -sticky news
	   grid $w.new.hle -row 2 -column 1 -rowspan 1 -columnspan 1 -sticky news
	   grid $w.new.hlb -row 2 -column 2 -rowspan 1 -columnspan 1 -sticky news
	   }

	if { $blk_ll_ } {
	   grid $w.new.lll -row 3 -column 0 -rowspan 1 -columnspan 1 -sticky news
	   grid $w.new.lle -row 3 -column 1 -rowspan 1 -columnspan 1 -sticky news
	   grid $w.new.llb -row 3 -column 2 -rowspan 1 -columnspan 1 -sticky news
	   }

	if { $blk_ar_ } {
	   grid $w.new.aml -row 4 -column 0 -rowspan 1 -columnspan 1 -sticky news
	   grid $w.new.isauto -row 4 -column 1 -rowspan 1 -columnspan 1 -sticky news
	   if { [string trim $isauto] != [string trim $ma] } {
	       grid $w.new.ama -row 4 -column 2 -rowspan 1 -columnspan 1 -sticky news
	     } else {
	       grid $w.new.amm -row 4 -column 2 -rowspan 1 -columnspan 1 -sticky news
	     }
	   }
	grid $w.new.amd -row 5 -column 2 -rowspan 1 -columnspan 1 -sticky news
	
	catch { close  $eng4_pipe_multi }

	}

bind . <Control-c> {destroy .}
bind . <Control-C> {destroy .}
################# bind mouse stuff here ################
$w.frame.mess configure -cursor sb_left_arrow
bind $w.frame.mess <1> { 
 set blkno_ [$w.frame.mess get "current linestart + 0 chars" "current linestart + 4 chars" ]
 set blkno [expr $blkno_ + 0]
# exec /home/abacus/bashnet $NODE  /home/abacus/eng2 b$blkno,con,ama
# puts stdout "exec /home/abacus/bashnet $NODE  /home/abacus/eng2 b$blkno,con,ama"
## puts stdout "entry_stuff_multi_acb  $blkno  "
 entry_stuff_multi_acb  $blkno 
  }
set OLD_NODE "MaryHadALittleLamb"

proc get_values { } {
	global NODE
	global blob_data ra_data ra_block
	global ac_data ac_block
	global hl_data hl_block
	global ll_data ll_block
	global vn_data vn_block
	global ra3_pipe eng4_pipe sp3_pipe  sp_data sp_block
	global s13_pipe s23_pipe un3_pipe  si3_pipe
	global s1_block s2_block un_block  si_block
	global s1_data s2_data un_data  si_data
	global OLD_NODE
	
	if { $NODE != $OLD_NODE } {
	  if { [info exists eng4_pipe] } then {
	      catch { close $eng4_pipe }
	      unset eng4_pipe
	    }
	  }
	set OLD_NODE $NODE
	
## 	if { [info exists eng4_pipe] } then {
## 	  
## 	  } else {
## 	  set eng4_pipe [open  "| hose $NODE 9000 -slave " {RDWR } ]
## 	  fconfigure $eng4_pipe -buffering line
## 	  puts $eng4_pipe /home/abacus/eng4
## 	  }

	if { [info exists eng4_pipe] } then {
	  
	  } else {
	  set eng4_pipe [socket $NODE 9000]
	  fconfigure $eng4_pipe -buffering line
	  puts $eng4_pipe "/home/abacus/eng4 "
	  }
	
	
	foreach i [array names ll_block] {
	  if { $ll_block($i) <= 2 } then {
		puts $eng4_pipe ll$i
		set ll_data($i) [ gets $eng4_pipe ]
		incr ll_block($i) 1
		} else { unset ll_block($i) ; unset ll_data($i) }
	  }

	foreach i [array names hl_block] {
	  if { $hl_block($i) <= 2 } then {
		puts $eng4_pipe hl$i
		set hl_data($i) [ gets $eng4_pipe ]
		incr hl_block($i) 1
		} else { unset hl_block($i) ; unset hl_data($i) }
	  }

	foreach i [array names ac_block] {
	  if { $ac_block($i) <= 2 } then {
		puts $eng4_pipe ac$i
		set ac_data($i) [ gets $eng4_pipe ]
		incr ac_block($i) 1
		} else { unset ac_block($i) ; unset ac_data($i) }
	  }

	foreach i [array names vn_block] {
	  if { $vn_block($i) <= 2 } then {
		puts $eng4_pipe vn$i
		set vn_data($i) [ gets $eng4_pipe ]
		incr vn_block($i) 1
		} else { unset vn_block($i) ; unset vn_data($i) }
	  }

	foreach i [array names ra_block] {
	  if { $ra_block($i) <= 2 } then {
		puts $eng4_pipe ra$i
		set ra_data($i) [ gets $eng4_pipe ]
		incr ra_block($i) 1
		} else { unset ra_block($i) ; unset ra_data($i)  }
	  }
#; puts stdout "unset ra_($i)"

	foreach i [array names sp_block] {
	  if { $sp_block($i) <= 2 } then {
		puts $eng4_pipe sp$i
		set sp_data($i) [ gets $eng4_pipe ]
		incr sp_block($i) 1
		} else { unset sp_block($i) ; unset sp_data($i) }
	  }

	foreach i [array names s1_block] {
	  if { $s1_block($i) <= 2 } then {
		puts $eng4_pipe s1$i
		set s1_data($i) [ gets $eng4_pipe ]
		incr s1_block($i) 1
		} else { unset s1_block($i) ; unset s1_data($i) }
	  }

	foreach i [array names s2_block] {
	  if { $s2_block($i) <= 2 } then {
		puts $eng4_pipe s2$i
		set s2_data($i) [ gets $eng4_pipe ]
		incr s2_block($i) 1
		} else { unset s2_block($i) ; unset s2_data($i) }
	  }

	foreach i [array names si_block] {
	  if { $si_block($i) <= 2 } then {
		puts $eng4_pipe si$i
		set si_data($i) [ gets $eng4_pipe ]
		incr si_block($i) 1
		} else { unset si_block($i) ; unset si_data($i) }
	  }

	foreach i [array names un_block] {
	  if { $un_block($i) <= 2 } then {
		puts $eng4_pipe un$i
		set un_data($i) [ gets $eng4_pipe ]
		incr un_block($i) 1
		} else { unset un_block($i) ; unset un_data($i) }
	  }

}


