#!/bin/sh
# [info script] - ABACUS operator interface - trend page
# the next line restarts using wish \
exec wish "$0" "$@"


#set NODE	ast
set NODE	localhost
#set NODE	c2co
set mysqlhost "-h172.17.31.10"
set mysqlhost "-hlocalhost"

set font  -adobe-helvetica-medium-r-*-*-12-*-*-*-*-*-*-*

set w .
#cd /home/abacus/trenddatafiles/
####cd /home/abacus/

wm title $w "ABACUS Trend Display [info script]"
wm iconname $w "Trend"

set c ${w}frame.c
set tagnames xaxistext
set updateint 10

##################### bash-net substitute ############################

proc BashNetReader { sock } {
  global BashNetforever BashNetReaderResult
  gets $sock line
  if { $line == "e17971e17971" } {
    set BashNetforever 1
    catch {close $sock}
#puts stdout "BashNetReader: close $sock"
    catch {close $sock}
    return line
  }
  append BashNetReaderResult "$line\n"
  return line
}

proc BashNet { sock args } {
  global BashNetforever BashNetReaderResult

    set BashNetReaderResult ""
    set sock [socket $sock 9000]
#puts stdout "BashNet: set sock \[socket $sock 9000\]" 
    fconfigure $sock -blocking 1 -buffering line -translation lf 
    puts $sock "[lrange $args 0 end];echo;echo e17971e17971;"
    flush $sock

    fileevent $sock readable [list BashNetReader $sock]
    vwait BashNetforever
    return $BashNetReaderResult
}
##################### end of bash-net substitute ############################

label ${w}msg -font $font -justify left 
#-text "This is ${w}msg /home/abacus/t2.sh" -wraplength 5i 
pack ${w}msg -side bottom

frame ${w}t
pack ${w}t  -side top
button ${w}t.close -text "CLOSE" -command { exit }
button ${w}t.newp -text "New trend page" -command {
 exec nice [info script]  -geometry +0+0 &
 exit
 }


button ${w}t.newf -text "Choose trend" -command {
 global NODE thefile
 set thefile [tk_getOpenFile -initialdir /home/abacus/trendfiles-sim/]
 if { $thefile != ""} { 
   after cancel [after info]
   clearvars
   foreach tagname $tagnames {catch { $c delete line -tag $tagname } }
   source $thefile
   drawlines
   }
}
set auto_upp 0
set auto_upp 1
button ${w}t.auto -text "auto updating" -command {
  set auto_upp 1
  after cancel drawlines
  drawlines
  }
button ${w}t.hand -text "stop updating" -command {
  set auto_upp 0
  ${w}frame2.text1 insert 1.0 [format " Update manually " t ]
  after cancel drawlines
  }
button ${w}t.updat -text "update now" -command {
  set auto_upp 0
  drawlines
  }


button ${w}t.ps -text "make psfile" -command {
 after cancel [after info]
 $c postscript -file  \
 [tk_getSaveFile -initialdir /home/abacus/trendfiles-sim/ -initialfile trend.ps]\
 -height 330 -width 500 -rotate 1 
 }
button ${w}t.save -text "Save Trend file" -command {
 set filename [tk_getSaveFile -initialdir /home/abacus/trendfiles-sim/  -initialfile [file tail $thefile]]
 if { $filename != ""} { 
   set fileId [open $filename w]
   puts $fileId [format "#!/home/abacus/trend2.sh"]
   puts $fileId "# $filename created by /home/abacus/trend2.sh\n# at [exec date]\n"
   puts $fileId "set xmag	$xmag"
   puts $fileId "set ymag	$ymag\n"
   puts $fileId "set canvasbg	$canvasbg\n"
   puts $fileId "set updateint	$updateint\n"
   
   foreach n {0 1 2 3 4 5 6 7 8 9} {
   	puts $fileId "set acb($n)    	$acb($n)"
   	puts $fileId "set trendfile($n)	$trendfile($n)"
   	puts $fileId "set ymax($n)   	$ymax($n)"
   	puts $fileId "set ymin($n)   	$ymin($n)"
   	puts $fileId "set colour($n) 	$colour($n)"
   	puts $fileId "set width($n)  	$width($n)\n"
   }
   close $fileId 
 }
 }
#pack ${w}t.newf ${w}t.newp ${w}t.ps ${w}t.save ${w}t.close  -side left
#pack ${w}t.newf ${w}t.newp ${w}t.save ${w}t.updat  ${w}t.close  -side left
pack ${w}t.newf ${w}t.newp ${w}t.auto ${w}t.hand ${w}t.updat  ${w}t.close  -side left


frame ${w}frame
pack ${w}frame -side top -fill both -expand yes
set canvasbg #d9d9d9

canvas $c -scrollregion {-1010 -600 30 600} -width 500 -height 330  \
	-relief sunken -borderwidth 2 \
	-xscrollcommand "${w}frame.hscroll set" \
	-yscrollcommand "${w}frame.vscroll set" -background $canvasbg
scrollbar ${w}frame.vscroll -orient vertical   -command "$c yview" -width 10
# -jump 1
scrollbar ${w}frame.hscroll -orient horizontal -command "$c xview" -width 10
# -jump 1

#-in ${w}frame
grid $c   -row 0 -column 0 -rowspan 1 -columnspan 1 -sticky news
grid ${w}frame.vscroll -row 0 -column 1 -rowspan 1 -columnspan 1 -sticky news
grid ${w}frame.hscroll -row 1 -column 0 -rowspan 1 -columnspan 1 -sticky news

grid rowconfig    ${w}frame 0 -weight 1 -minsize 0
grid columnconfig ${w}frame 0 -weight 1 -minsize 0

###############################################
# Stuff att the bottom
###############################################

frame ${w}frame2
pack ${w}frame2 -side top -fill both -expand yes
button ${w}frame2.left  -text "<<" -command doleft
button ${w}frame2.right -text ">>" -command doright
button ${w}frame2.up    -text "^^" -command doup
button ${w}frame2.down  -text "vv" -command dodown
button ${w}frame2.cent  -text "norm" -command docent

text ${w}frame2.text1 -width 60 -height 1 -wrap none
bind ${w}frame2.text1 <3> "setsignals"


grid ${w}frame2.left -row 1 -column 0 -rowspan 1 -columnspan 1 -sticky news
grid ${w}frame2.up -row 0 -column 1 -rowspan 1 -columnspan 1 -sticky news
grid ${w}frame2.right -row 1 -column 2 -rowspan 1 -columnspan 1 -sticky news
grid ${w}frame2.down -row 2 -column 1 -rowspan 1 -columnspan 1 -sticky news
grid ${w}frame2.cent -row 1 -column 1 -rowspan 1 -columnspan 1 -sticky news
grid ${w}frame2.text1  -row 0 -column 5 -columnspan 1 -rowspan 10 -sticky news

#grid rowconfig    ${w}frame2 0 -weight 1 -minsize 0
#grid columnconfig ${w}frame2 0 -weight 1 -minsize 0

######## Setup the initial scroll position ########
$c yview moveto 0.25
$c xview moveto 1.0


###################
proc doleft  {} { global NODE xmag ymag ; set xmag [expr $xmag * 2] ; after cancel drawlines ; drawlines }
proc doright {} { global NODE xmag ymag ; set xmag [expr $xmag / 2] ; after cancel drawlines ; drawlines }
proc doup    {} { global NODE xmag ymag ; set ymag [expr $ymag * 2] ; after cancel drawlines ; drawlines }
proc dodown  {} { global NODE xmag ymag ; set ymag [expr $ymag / 2] ; after cancel drawlines ; drawlines }
proc docent  {} { global NODE xmag ymag c tagnames thefile acb trendfile ymax ymin colour width
 source $thefile
 after cancel drawlines ; drawlines 
 $c yview moveto 0.25; $c xview moveto 1.0 
 }

###############################################
proc makelines {blkno filename yymax yymin colour width tagname} {
	global NODE c axcol tagnames linecnt
	global NODE xmag ymag mysqlhost

	catch { $c delete line -tag $tagname }
	catch { $c delete text -tag xaxistext }
	lappend tagnames $tagname
	set tdata2 "$c create line "

## 	append tdata2 [exec /usr/local/mysql/bin/mysql $mysqlhost -s -B abacus -e \
## 	 "SELECT 	(TIME_TO_SEC(timdat)/60-TIME_TO_SEC(now())/60)
## 			+1440*(TO_DAYS(timdat)-TO_DAYS(now())),ra 
## 	  FROM		hist_1m WHERE b=$blkno  
## 		AND	(TIME_TO_SEC(timdat)/60-TIME_TO_SEC(now())/60)
## 			+1440*(TO_DAYS(timdat)-TO_DAYS(now())) > -1010 
## 	  ORDER BY	timdat desc" ]


##
	append tdata2 [BashNet $NODE /home/abacus/trendmem $filename get $blkno 1000]

	lappend tdata2 "-tag" $tagname "-fill" $colour "-width" $width
	catch { eval $tdata2  }
	
	
##	set ys [expr $ymag * ( -300 / ( $yymax - $yymin ) ) ]
##	set ym [expr $yymin / 1.6]

## 	set ym [expr $yymin / 1.28 ]
## 	;# ymax-ymin = 100
## 	set ym [expr $yymin * 0.860 ]  ;#  right at ymag = 2
## 	set ym [expr $yymin * 0.924 ]  ;#  right at ymag = 4
## 	set ym [expr $yymin * 0.960 ]  ;#  right at ymag = 8
## 	set ym [expr $yymin * 0.750 ]  ;#  ok at ymag = 1
## 	;# ymax-ymin = 50
## 	set ym [expr $yymin * 0.860 ]  ;#  ok at ymag = 1
## 	set ym [expr $yymin * 0.925 ]  ;#  right at ymag = 2
	set ym [expr $yymin * (1 - ( $yymax - $yymin )/ ( 314 * $ymag  ) ) ]

	set ys [expr $ymag * ( -300 / ( $yymax - $yymin ) ) ]
	$c scale $tagname 0 $ym $xmag $ys
	$c scale xaxistext 0 0 $xmag 1
	
	update idletasks

	}

######## Draw the axes ############
set axcol #5eb06c
set axcol black
$c create line -16000 0 16000 0 -tag xaxis -fill $axcol -width 2
$c create line -16000 -300 16000 -300 -tag xaxis -fill $axcol -width 1
$c create line 0 -16000 0 16000 -tag yaxis -fill $axcol -width 2
foreach yy {0 10 20 30 40 50 60 70 80 90 100 110 120 130 140 150 160 170 180 190 200 \
	 -10 -20 -30 -40 -50 -60 -70 -80 -90 -100 -110 -120 -130 -140 -150 -160 -170 -180 -190 -200 } {
	set y [expr $yy * -3]
	$c create line -10 $y 0 $y  -tag xaxis -fill $axcol -width 1
	$c create text 5 $y  -fill $axcol -text [format "%2d" [expr $yy / 1]] -tag xaxis -anchor w
	}
###############################################
proc makeaxes {blkno filename yymax yymin colour width tagname} {
	global NODE c axcol tagnames linecnt
	global NODE xmag ymag mysqlhost
	global axcol 

	catch { $c delete line -tag xaxis }
	catch { $c delete text -tag xaxis }
	set nrxaxis [expr 10 * $xmag ]
	set skxaxis [expr 128.0 / $xmag ]
	set xastr [BashNet $NODE /home/abacus/trendmem $filename get 0 $nrxaxis $skxaxis  ]
	#set xastr [exec /usr/local/mysql/bin/mysql $mysqlhost -s -B abacus -e "SELECT DATE_FORMAT(timdat,'%H:%i') FROM hist_1m WHERE b=57  AND (TIME_TO_SEC(now())/60-TIME_TO_SEC(timdat)/60) < 1000 and (TIME_TO_SEC(now())/60-TIME_TO_SEC(timdat)/60)%$skxaxis=0 ORDER BY timdat desc" ]
	set xstart 0
	foreach xval $xastr {
		eval "$c create text $xstart 15 -fill $axcol -text $xval -tag xaxistext "
		eval "$c create text $xstart 300 -fill $axcol -text $xval -tag xaxistext "
		eval "$c create text $xstart -285 -fill $axcol -text $xval -tag xaxistext "
		$c create line $xstart 0 $xstart -10 -fill $axcol -tag xaxistext 
		$c create line $xstart 1000 $xstart -1000 -fill $axcol -tag xaxistext 
		set xstart [expr $xstart - $skxaxis ]
		}
	

	set ys [expr $ymag * ( -300 / ( $yymax - $yymin ) ) ]
	set ym [expr 1 * $yymin]
	$c scale $tagname 0 $ym $xmag $ys
	$c scale xaxistext 0 0 $xmag 1
##	$c scale xaxistext 0 $ym $xmag $ys

	######## Draw the axes ############
	set axcol #5eb06c
	set axcol black
	
	$c create line -16000 0 16000 0 -tag xaxis -fill $axcol -width 2
	$c create line -16000 -300 16000 -300 -tag xaxis -fill $axcol -width 1
	$c create line 0 -16000 0 16000 -tag yaxis -fill $axcol -width 2
	foreach yy {0 10 20 30 40 50 60 70 80 90 100 110 120 130 140 150 160 170 180 190 200 \
		 -10 -20 -30 -40 -50 -60 -70 -80 -90 -100 -110 -120 -130 -140 -150 -160 -170 -180 -190 -200 } {
		set y [expr $yy * -3]
		$c create line -10 $y 0 $y  -tag xaxis -fill $axcol -width 1
		$c create text 5 $y  -fill $axcol -text [format "%2d" [expr $yy / 1]] -tag xaxis -anchor w
		}
	$c scale xaxis 0 0 $xmag $ymag

	}

###############################################
proc drawlines {} {
	global NODE updateint auto_upp
	global NODE  xmag ymag c canvasbg thefile w linecnt
 	global NODE  acb trendfile ymax ymin colour width mysqlhost
 	
 	if {$xmag < 1.0} { set xmag 1.0 }
 	if {$ymag < 0.0625} { set ymag 0.0625 }
 	if {$xmag > 16.0} { set xmag 16.0 }
 	if {$ymag > 16.0} { set ymag 16.0 }
 	
 	set x0 [expr -1010 * $xmag]
 	set y0 [expr -600  * $ymag]
 	set x1 30
 	set y1 [expr  600  * $ymag]
	
	$c configure -scrollregion "$x0 $y0 $x1 $y1" -background $canvasbg
	${w}frame2.text1 delete @1,0 end
	set thefiletail [file tail $thefile]
	wm title $w "ABACUS Trend Display [info script] - $thefiletail"
	
	
	if { $auto_upp } { ${w}frame2.text1 insert end [format " Update interval %d sec" $updateint ]
	 } else {${w}frame2.text1 insert end [format " Update manually " $updateint ]
	 }
	${w}frame2.text1 insert end [format " (curve updating) " $updateint ] tagtag
	${w}frame2.text1 insert end [format "\n" $updateint ]
	${w}frame2.text1 tag configure tagtag -foreground red
	# -background $canvasbg
	${w}frame2.text1 insert end [format "%5.5s %-24.24s %8.8s  %8.8s - %8.8s\n" BLOCK {Signal name} {value}  X0 X100 ]
	
	set linecnt 1
	foreach var {0 1 2 3 4 5 6 7 8 9} {
		if {$acb($var) == ""} continue
		incr linecnt
		set si [BashNet $NODE /home/abacus/si $acb($var)]

		set ra [BashNet $NODE /home/abacus/ra $acb($var) %8.3g]
		
		set linetext [format "%5d %-24.24s %8.3f  %8.3f - %8.3f\n" $acb($var) $si $ra  $ymin($var) $ymax($var)]
		${w}frame2.text1 insert end  $linetext tagn$var
		${w}frame2.text1 tag configure tagn$var -foreground $colour($var) -background $canvasbg
	}
	update idletask	     

	foreach var {0 1 2 3 4 5 6 7 8 9} {
		catch { $c delete line -tag tagn$var }
		if {$acb($var) == ""} continue
		makelines $acb($var) $trendfile($var) \
		  $ymax($var) $ymin($var) $colour($var) $width($var) tagn$var 
	}
	set var 0
	makeaxes $acb($var) $trendfile($var) \
		  $ymax($var) $ymin($var) $colour($var) $width($var) tagn$var
		  
	${w}frame2.text1 configure -height [expr $linecnt + 1 ]
	
	${w}frame2.text1 delete [ ${w}frame2.text1 search "(" 1.0] 1.end
#	${w}frame2.text1 tag configure tagtag -foreground $canvasbg


	after cancel drawlines
	if { $auto_upp } { after [expr $updateint * 1000] drawlines }
}

proc clearvars {} {
	global NODE  xmag ymag canvasbg c
 	global NODE  acb trendfile ymax ymin colour width
	
	set canvasbg #d9d9d9
	set colour(0)	black
	set colour(1)	red
	set colour(2)	blue
	set colour(3)	green
	set colour(4)	brown
	set colour(5)	orange
	set colour(6)	cyan3
	set colour(7)	white
	set colour(8)	SeaGreen3
	set colour(9)	PaleGreen4
	
	foreach var {0 1 2 3 4 5 6 7 8 9} {
		eval {set acb($var)		""}
		eval {set trendfile($var)	""}
		eval {set ymax($var)		100.0}
		eval {set ymin($var)		0.0}
		eval {set width($var)		2}
		}
	
	set xmag	1.0
	set ymag	1.0


	}

########################################################
bind $c <3> "setcanvasbg"
proc setcanvasbg {} {
	global NODE canvasbg
	set canvasbg1 [tk_chooseColor]
	if { $canvasbg1 != "" } {
		set canvasbg $canvasbg1
		after cancel [after info]
		drawlines
		
		}
	}

proc UpdateInterval {} {
	global NODE updateint
	catch {destroy .a}
	toplevel .a
	wm title .a "Update Interval"
	entry .a.e		-width 40
	.a.e insert end $updateint
	
	button .a.ok -text OK	-command {
		set updateint	[.a.e get]
		catch {destroy .a}
		}
	button .a.cancel -text CANCEL	-command {catch {destroy .a}}
	pack .a.e .a.cancel .a.ok 
}
proc setsignals {} {
	global NODE acb colour
	catch {destroy .a}
	toplevel .a
	wm title .a "SIGNALS"

	button .a.b -text [format "%-25.25s" "Update interval"] \
	 -command "UpdateInterval" -foreground $colour(0)

	button .a.b1 -text [format "%-25.25s" "Signal 1 $acb(1)"] -command "setsignals2 1" -foreground $colour(1)
	button .a.b2 -text [format "%-25.25s" "Signal 2 $acb(2)"] -command "setsignals2 2" -foreground $colour(2)
	button .a.b3 -text [format "%-25.25s" "Signal 3 $acb(3)"] -command "setsignals2 3" -foreground $colour(3)
	button .a.b4 -text [format "%-25.25s" "Signal 4 $acb(4)"] -command "setsignals2 4" -foreground $colour(4)
	button .a.b5 -text [format "%-25.25s" "Signal 5 $acb(5)"] -command "setsignals2 5" -foreground $colour(5)
	button .a.b6 -text [format "%-25.25s" "Signal 6 $acb(6)"] -command "setsignals2 6" -foreground $colour(6)
	button .a.b7 -text [format "%-25.25s" "Signal 7 $acb(7)"] -command "setsignals2 7" -foreground $colour(7)
	button .a.b8 -text [format "%-25.25s" "Signal 8 $acb(8)"] -command "setsignals2 8" -foreground $colour(8)
	button .a.b9 -text [format "%-25.25s" "Signal 9 $acb(9)"] -command "setsignals2 9" -foreground $colour(9)
	button .a.b0 -text [format "%-25.25s" "Signal 0 $acb(0)"] -command "setsignals2 0" -foreground $colour(0)
	pack .a.b .a.b0 .a.b1 .a.b2 .a.b3 .a.b4 .a.b5 .a.b6 .a.b7 .a.b8 .a.b9 \
	 -side top  -fill both -expand no
	}
proc setsignals2 { num } {
	global NODE acb trendfile ymax ymin colour width num2
	
	set num2 $num
	catch {destroy .a}
	toplevel .a
	wm title .a "LINE $num"
	entry .a.acb		-width 40
	entry .a.trendfile	-width 40
	bind  .a.trendfile	<3> {
		set filename1 [tk_getOpenFile -initialdir /home/abacus/trenddatafiles/ \
			 -title Trend-data-file]
		if { $filename1 != "" } {
			set trendfile($num2) $filename1
			.a.trendfile delete 0 end
			.a.trendfile insert end $trendfile($num2)
			}
		}
	entry .a.ymax		-width 40
	entry .a.ymin		-width 40
	entry .a.colour		-width 40
	bind  .a.colour	<3> {
		set colour1 [tk_chooseColor]
		if { $colour1 != "" } {
			set colour($num2) $colour1
			.a.colour delete 0 end
			.a.colour insert end $colour($num2)
			}
		}
	entry .a.width		-width 40
	button .a.ok -text OK	-command {
		set acb($num2)		[.a.acb       get]
		set trendfile($num2)    [.a.trendfile get]
		set ymax($num2)         [.a.ymax      get]
		set ymin($num2)         [.a.ymin      get]
		set colour($num2)       [.a.colour    get]
		set width($num2)        [.a.width     get]
		after cancel [after info]
		drawlines
		
		catch {destroy .a}
		}
	button .a.cancel -text CANCEL	-command {catch {destroy .a}}
		
	.a.acb  	 insert end $acb($num)
	.a.trendfile	 insert end $trendfile($num)
	.a.ymax 	 insert end $ymax($num)
	.a.ymin 	 insert end $ymin($num)
	.a.colour	 insert end $colour($num)
	.a.width	 insert end $width($num)
	
	label .a.acblbl		-text "acb"
	label .a.trendfilelbl	-text "trendfile"
	label .a.ymaxlbl		-text "ymax"
	label .a.yminlbl		-text "ymin"
	label .a.colourlbl	-text "colour"
	label .a.widthlbl	-text "width"

	grid  .a.acblbl		-row 1 -column 0 -rowspan 1 -columnspan 1 -sticky news
	grid  .a.acb		-row 1 -column 1 -rowspan 1 -columnspan 2 -sticky news
#	grid  .a.trendfilelbl	-row 2 -column 0 -rowspan 1 -columnspan 1 -sticky news
#	grid  .a.trendfile	-row 2 -column 1 -rowspan 1 -columnspan 2 -sticky news
	grid  .a.ymaxlbl	-row 3 -column 0 -rowspan 1 -columnspan 1 -sticky news
	grid  .a.ymax		-row 3 -column 1 -rowspan 1 -columnspan 2 -sticky news
	grid  .a.yminlbl	-row 4 -column 0 -rowspan 1 -columnspan 1 -sticky news
	grid  .a.ymin		-row 4 -column 1 -rowspan 1 -columnspan 2 -sticky news
	grid  .a.colourlbl	-row 5 -column 0 -rowspan 1 -columnspan 1 -sticky news
	grid  .a.colour		-row 5 -column 1 -rowspan 1 -columnspan 2 -sticky news
	grid  .a.widthlbl	-row 6 -column 0 -rowspan 1 -columnspan 1 -sticky news
	grid  .a.width		-row 6 -column 1 -rowspan 1 -columnspan 2 -sticky news
	grid  .a.ok		-row 7 -column 1 -rowspan 1 -columnspan 1 -sticky news
	grid  .a.cancel		-row 7 -column 2 -rowspan 1 -columnspan 1 -sticky news
	
	
	}


# Ask for and then get the trendfile
${w}t.newf invoke 

